c  Fichier prod_qua_c.f
c
c*******************************************************     
      real*8 function PRODUIT_2D_c(K,GRAD,nbr1,nbr2)
c*******************************************************
c
c   Cette fonction calcule le produit scalaire de [K(x)GRAD(u).GRAD(v)],
c   u et v designant deux fonctions de base quelconque du
c   quadrilatere.  
c
c   K: tableau contenant le tenseur des permeabilites
c   GRAD: tableau contenant les valeurs des  gradiants
c         des fonctions de base
c   nbr1,nbr2: numero designant la nbr1ieme et la nbr2ieme
c              fonction de base
c    


      implicit none
      integer   nbr1,nbr2   
      real*8    K,GRAD
      dimension K(2,*),GRAD(4,*)
c
c produit scalaire
c
      PRODUIT_2D_c=K(1,1)*GRAD(nbr1,1)*GRAD(nbr2,1)+
     @           K(1,2)*GRAD(nbr1,2)*GRAD(nbr2,1)+
     @           K(2,1)*GRAD(nbr1,1)*GRAD(nbr2,2)+
     @           K(2,2)*GRAD(nbr1,2)*GRAD(nbr2,2)
      
      RETURN
      end
                         

                         

