c  Fichier  rige_qua_c.f
c
c*****************************************************************
      real*8 function INTEGRALE_2D_c(GRAD,N1,N2,N3,N4,K,det,nbr1,nbr2)
c*****************************************************************
c
c   Cette fonction calcule l'approxiamtion de l'integrale de 
c   [K(x)GRAD(u).GRAD(v)] sur un quadrilatere.
c    u et v designant deux fonctions de base quelconque
c   du quadrilatere.
c   On utilise la formule p.??? du  livre 'PRESENTATION DE LA METHODE
c   DES ELEMENTS FINIS' (T.Touzot) 19??.
c
c   N1,N2,N3,N4: contient les numeros, ainsi que les coordonnees des
c                quatre points qui constituent le quadrilatere
c   K: tableau contenant le tenseur des permeabilites
c   GRAD: tableau contenant les valeurs des  gradiants
c         des fonctions de base
c   nbr1,nbr2: numero designant la nbr1ieme et la nbr2ieme
c              fonction de base
c   det: jacobien de la transformation: carre de reference --> quadrilatere  
c
c

      implicit none

      integer   nbr1,nbr2          
      real*8    somme,GRAD,N1,N2,N3,N4,det,K,PRODUIT_2D_c,point
      dimension N1(*),N2(*),N3(*),N4(*),K(2,*),GRAD(4,*)

      point=1.d0/SQRT(3.d0)

      call GRADIANT_2D_c(GRAD,det,N1,N2,N3,N4,point,point) 
      somme=PRODUIT_2D_c(K,GRAD,nbr1,nbr2)                   
      call GRADIANT_2D_c(GRAD,det,N1,N2,N3,N4,-point,point) 
      somme=somme+PRODUIT_2D_c(K,GRAD,nbr1,nbr2)             
      call GRADIANT_2D_c(GRAD,det,N1,N2,N3,N4,-point,-point) 
      somme=somme+PRODUIT_2D_c(K,GRAD,nbr1,nbr2)            
      call GRADIANT_2D_c(GRAD,det,N1,N2,N3,N4,point,-point) 
      somme=somme+PRODUIT_2D_c(K,GRAD,nbr1,nbr2)             
      
      INTEGRALE_2D_c=somme*ABS(det)    
      
      RETURN
      end
