abstract class Basis3DObject extends Object {
  abstract double evaluate(double x, double y, double z);
  abstract double evaluate(double x, double xl, double xr,
                           double y, double yl, double yr,
                           double z, double zl, double zr);
  abstract double dbydx(double x, double y, double z);
  abstract double dbydx(double x, double xl, double xr,
                        double y, double yl, double yr,
                        double z, double zl, double zr);
  abstract double dbydy(double x, double y, double z);
  abstract double dbydy(double x, double xl, double xr,
                        double y, double yl, double yr,
                        double z, double zl, double zr);
  abstract double dbydz(double x, double y, double z);
  abstract double dbydz(double x, double xl, double xr,
                        double y, double yl, double yr,
                        double z, double zl, double zr);
  abstract void setDomain(double xl, double xr,
                          double yl, double yr,
                          double zl, double zr);
  abstract double getXLeftDomain();
  abstract double getXRightDomain();
  abstract double getYLeftDomain();
  abstract double getYRightDomain();
  abstract double getZLeftDomain();
  abstract double getZRightDomain();
}
