public class PiecewiseConstant1D extends Basis1DObject{
  // constructor with all arguments
  public PiecewiseConstant1D() {
    this(0.0, 1.0);
  }
  public PiecewiseConstant1D(double xl, double xr) {
    computeParameters(xl, xr);
  }
  public double evaluate(double x) {
    if(x>= xleft && x <= xright) return 1.0;
    return 0.0;
  }
  public double evaluate(double x, double xleft, double xright) {
    if(x>= xleft && x <= xright) return 1.0;
    return 0.0;
  }
  public double derivative(double x) {
    return 0.0;
  }
  public double derivative(double x, double xleft, double xright) {
    return 0.0;
  }
  public void computeParameters(double xl, double xr) {
    if(xl > xr) {
      xleft = xr;
      xright = xl;
    } else {
      xleft = xl;
      xright = xr;
    }
    dx = xright - xleft;
  }
  public void setDomain(double xl, double xr) {
    computeParameters(xl, xr);
  }
  public double getLeftDomain() {
    return xleft;
  }
  public double getRightDomain() {
    return xright;
  }
  public static void main(String args[]) {
    PiecewiseConstant1D pl1d = new PiecewiseConstant1D();
    System.out.println(pl1d.toString());
    double dx = 0.01;
    double xleft = 0.0;
    double xright = 1.0;
    for(int i=-4; i<105; i++) {
      double xval = i * dx;
      System.out.println("  " + i + "  " + pl1d.evaluate(xval,xleft,xright)
                        + "  " + pl1d.derivative(xval,xleft,xright));
    }
    xleft = 0.31;
    xright = 0.94;
    for(int i=-4; i<105; i++) {
      double xval = i * dx;
      System.out.println("  " + i + "  " + pl1d.evaluate(xval,xleft,xright)
                        + "  " + pl1d.derivative(xval,xleft,xright));
    }
  }

  // local variables
  private double xleft;
  private double xright;
  private double dx;
}
