import java.util.Vector;
public class PointSources extends Object {

  public PointSources() {
    sources = new Vector();
    noOfSources = 0;
  }

  public PointSources(double x, double y, double z, double val) {
    double [] tmp = new double [4];
    tmp[0] = x;
    tmp[1] = y;
    tmp[2] = z;
    tmp[3] = val;
    sources = new Vector();
    sources.add(tmp);
    getNumberOfSources();
  }

  public void addSource(double x, double y, double z, double value) {
    double [] tmp = new double [4];
    tmp[0] = x;
    tmp[1] = y;
    tmp[2] = z;
    tmp[3] = value;
    sources.add(tmp);
    getNumberOfSources();
  }

  public void removeSource(int index) {
    if(index < 0 || index >= noOfSources) return;
    sources.remove(index);
    getNumberOfSources();
  }

  public void removeSource(double x, double y, double z) {
    int index = -1;
    double mindist = 1000000.0;
    for(int i=0; i<noOfSources; i++) {
      double [] ps = (double []) sources.get(i);
      double xdiff = ( x - ps[0] ) * ( x - ps[0] ); 
      double ydiff = ( y - ps[1] ) * ( y - ps[1] ); 
      double zdiff = ( z - ps[2] ) * ( z - ps[2] ); 
      double dist = Math.sqrt(xdiff + ydiff + zdiff );
      if(dist < mindist) index = i;
    }
    sources.remove(index);
    getNumberOfSources();
  }

  public int getNumberOfSources() {
    noOfSources = 0;
    if(sources != null) noOfSources = sources.size();
    return noOfSources;
  }

  public Vector getSources() {
    return sources;
  }

  public double [] getSource(int n) {
    if(n < 0) return null;
    if(n >= noOfSources) return null;
    return ((double []) sources.get(n));
  }

  public String toString() {
    String s = "\n PointSources Information:\n";
    for(int i=0; i<noOfSources; i++) {
      double [] d = (double []) sources.get(i);
      s = s + "\n Source " + i + "\n";
      s = s + "\n     x location: " + d[0];
      s = s + "\n     y location: " + d[1];
      s = s + "\n     z location: " + d[2] + "\n";
      s = s + "\n     source value: " + d[3] + "\n";
    }
    return s;
  }

  public static void main(String args[]) {
    PointSources pso = new PointSources(0.0, 0.0, 0.0, 1.0);
    System.out.println(pso.toString());
    pso.addSource(0.5, 0.5, 0.5, 2.0);
    System.out.println(pso.toString());
  }

  // local variables
  private int noOfSources = 0;
  private Vector sources;

}
