import java.awt.*;
import java.awt.event.*;
public class SetValuesDialog extends Dialog implements ActionListener
{
  
  public SetValuesDialog(Frame frame) {
    this(frame, null);
  }
  
  public SetValuesDialog(Frame frame, Color color) {

    // call the dialog constructor from the super
    super(frame, "Set Values Dialog", true);

    // set up the panel to display
    panel = new Panel();
    panel.setLayout(new BorderLayout());

    // set up the label
    panelLabel = new Label("Set Tensor Values", Label.CENTER);
    panel.add("North", panelLabel);

    // put up all the tensor information
    valuePanel = new Panel();
    valuePanel.setLayout(new GridLayout(3,6));
    if(color != null) {
      valuePanel.setBackground(color);
    } else {
      valuePanel.setBackground(Color.white);
    }
      valuePanel.add(lxx);
      valuePanel.add(txx);
      valuePanel.add(lxy);
      valuePanel.add(txy);
      valuePanel.add(lxz);
      valuePanel.add(txz);
      valuePanel.add(lyx);
      valuePanel.add(tyx);
      valuePanel.add(lyy);
      valuePanel.add(tyy);
      valuePanel.add(lyz);
      valuePanel.add(tyz);
      valuePanel.add(lzx);
      valuePanel.add(tzx);
      valuePanel.add(lzy);
      valuePanel.add(tzy);
      valuePanel.add(lzz);
      valuePanel.add(tzz);

    // add the panel for the tensor values
    panel.add("Center",valuePanel);

    // add the panel to the box
    add(panel);

    // set the thing to a fixed size
    setSize(width, height);
    show();

  }

  public void actionPerformed(ActionEvent e) {
  }

  public Double [] DoubleValues() {
    Double [] values = new Double [9];
    try{values[0] = Double.valueOf(txx.getText());
    } catch (NumberFormatException nfe) {
      values[0] = new Double(0.0);
    }
    try{values[1] = Double.valueOf(txy.getText());
    } catch (NumberFormatException nfe) {
      values[1] = new Double(0.0);
    }
    try{values[2] = Double.valueOf(txz.getText());
    } catch (NumberFormatException nfe) {
      values[2] = new Double(0.0);
    }
    try{values[3] = Double.valueOf(tyx.getText());
    } catch (NumberFormatException nfe) {
      values[3] = new Double(0.0);
    }
    try{values[4] = Double.valueOf(tyy.getText());
    } catch (NumberFormatException nfe) {
      values[4] = new Double(0.0);
    }
    try{values[5] = Double.valueOf(tyz.getText());
    } catch (NumberFormatException nfe) {
      values[5] = new Double(0.0);
    }
    try{values[6] = Double.valueOf(tzx.getText());
    } catch (NumberFormatException nfe) {
      values[6] = new Double(0.0);
    }
    try{values[7] = Double.valueOf(tzy.getText());
    } catch (NumberFormatException nfe) {
      values[7] = new Double(0.0);
    }
    try{values[8] = Double.valueOf(tzz.getText());
    } catch (NumberFormatException nfe) {
      values[8] = new Double(0.0);
    }
    return values;
  }

  public double [] doubleValues() {
    double [] values = new double [9];
    try{values[0] = Double.valueOf(txx.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[0] = 0.0;
    }
    try{values[1] = Double.valueOf(txy.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[1] = 0.0;
    }
    try{values[2] = Double.valueOf(txz.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[2] = 0.0;
    }
    try{values[3] = Double.valueOf(tyx.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[3] = 0.0;
    }
    try{values[4] = Double.valueOf(tyy.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[4] = 0.0;
    }
    try{values[5] = Double.valueOf(tyz.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[5] = 0.0;
    }
    try{values[6] = Double.valueOf(tzx.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[6] = 0.0;
    }
    try{values[7] = Double.valueOf(tzy.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[7] = 0.0;
    }
    try{values[8] = Double.valueOf(tzz.getText()).doubleValue();
    } catch (NumberFormatException nfe) {
      values[8] = 0.0;
    }
    return values;
  }

  public void setValues(Double [] values) {
    txx.setText(values[0].toString());
    txy.setText(values[1].toString());
    txz.setText(values[2].toString());
    tyx.setText(values[3].toString());
    tyy.setText(values[4].toString());
    tyz.setText(values[5].toString());
    tzx.setText(values[6].toString());
    tzy.setText(values[7].toString());
    tzz.setText(values[8].toString());
  }

  public void setValues(double [] values) {
    txx.setText(new Double(values[0]).toString());
    txy.setText(new Double(values[1]).toString());
    txz.setText(new Double(values[2]).toString());
    tyx.setText(new Double(values[3]).toString());
    tyy.setText(new Double(values[4]).toString());
    tyz.setText(new Double(values[5]).toString());
    tzx.setText(new Double(values[6]).toString());
    tzy.setText(new Double(values[7]).toString());
    tzz.setText(new Double(values[8]).toString());
  }

  public static void main(String args[]) {
    // pretty simple test
    Frame f = new Frame("Set Values Dialog Test");
    String s = "A very long string to test things and such";
    SetValuesDialog wd2 = new SetValuesDialog(f, Color.red);
    double [] values = new double [9];
    for(int i=0; i<9; i++) values[i] = (double) i;
    wd2.setValues(values);
    System.exit(0);

  }

  // local variables
  private Panel panel;
  private Label panelLabel;
  private int width = 450;
  private int height = 150;

  private Panel valuePanel;
    private Label lxx = new Label("txx", Label.CENTER);
    private Label lxy = new Label("txy", Label.CENTER);
    private Label lxz = new Label("txz", Label.CENTER);
    private Label lyx = new Label("tyx", Label.CENTER);
    private Label lyy = new Label("tyy", Label.CENTER);
    private Label lyz = new Label("tyz", Label.CENTER);
    private Label lzx = new Label("tzx", Label.CENTER);
    private Label lzy = new Label("tzy", Label.CENTER);
    private Label lzz = new Label("tzz", Label.CENTER);
    private TextField txx = new TextField(10);
    private TextField txy = new TextField(10);
    private TextField txz = new TextField(10);
    private TextField tyx = new TextField(10);
    private TextField tyy = new TextField(10);
    private TextField tyz = new TextField(10);
    private TextField tzx = new TextField(10);
    private TextField tzy = new TextField(10);
    private TextField tzz = new TextField(10);

}
