import java.awt.*;
import java.awt.event.*;
import java.io.*;
public class StatusPanel extends Panel implements Runnable {
 
  public StatusPanel() {
    this("Status Info:", null, false);
  }
   
  public StatusPanel(String ls, String s, boolean b) {
    super();
    setLayout(new BorderLayout());

    if(ls != null) {
      statusLabel = new Label(ls);
    } else {
      statusLabel = new Label("Status Info:");
    }
    if(s != null) {
      workingString = s;
    } else {
      workingString = "";
    }
    statusLine = new TextField(workingString, 20);

    statusRunning = b;

    add("West", statusLabel);
    add("Center", statusLine);

  }

  public void run() {
    int cnt = 0;
    if(workingString == null) workingString = "";
    String os = workingString;
    statusLine.setBackground(Color.blue);
    statusLine.setForeground(Color.white);
    statusLine.setText(os);
    while(statusRunning) {
      cnt++;
      os = os + runningString;
      if(cnt == 40) {
        os = workingString;
        cnt = 0;
      }
      statusLine.setText(os);
      try {Thread.sleep(delay);
      } catch(InterruptedException ie) {
      }
    }
    statusThread = null;
  }

  public void startRunning(String s) {
    setStatusString(s);
    startRunning();
  }

  public void startRunning() {
    if(statusThread == null) statusThread = new Thread(this);
    statusRunning = true;
    if(!statusThread.isAlive()) statusThread.start();
  }

  public void stopRunning() {
    statusRunning = false;
    statusLine.setBackground(Color.white);
    statusLine.setForeground(Color.black);
  }

  public void stopRunning(String s) {
    stopRunning();
    setStatusString(s);
  }

  public void setStatusString(String s) {
    workingString = s;
    if(workingString == null) workingString = "";
    statusLine.setText(workingString);
  }

  public void clearStatus() {
    statusLine.setText("");
  }

  public void setDelay(int d) {
    delay = d;
    if(delay < minDelay) delay = minDelay;
  }

  public static void main(String args[]) {
    // pretty simple test
    Frame f = new Frame("Warning Frame Test");
    f.setSize(500,500);
      Panel panel = new Panel();
      panel.setLayout(new BorderLayout());
        Panel centerPanel = new Panel();
        StatusPanel sp = new StatusPanel(null, "test", false);
      panel.add("Center", centerPanel);
      panel.add("South", sp);
    f.add(panel);
    sp.startRunning();
    f.show();
  }

  private String workingString;
  private String runningString = "+";
  private Thread statusThread;
  private Label statusLabel;
  private TextField statusLine;
  private boolean statusRunning;
  private int delay = 500;
  private int minDelay = 100;

}
