import java.awt.*;
import java.awt.event.*;
public class WarningDialog extends Dialog implements ActionListener {
 
  public WarningDialog(Frame frame, String title, String s) {
    this(frame, title, s, null);
  }
   
  public WarningDialog(Frame frame, String title, String s, Color color) {
                                                                          
    // call the dialog constructor from the super
    super(frame, title, true);
                              
    // set up the panel to display
    panel = new Panel();
    panel.setLayout(new BorderLayout());
                                        
    // set the background color
    if(color != null) {
      panel.setBackground(color);
    } else {
      panel.setForeground(Color.black);
      panel.setBackground(Color.white);
    }
     
    // add the message to show the user
    message = new TextArea(s, 40, 5, TextArea.SCROLLBARS_VERTICAL_ONLY);
    panel.add("Center", message);
                                 
    // add a button to release control back to the program
    okButton = new Button("Okay");
    okButton.setBackground(Color.black);
    okButton.setForeground(Color.white);
    okButton.addActionListener(this);
    panel.add("South", okButton);
                                 
    // add the panel, set the size of the box and show it
    add(panel);

    // position the box
    Dimension d = frame.getSize();
    int xOffset = 0;
    int yOffset = 0;
    if(frame != null) {
      xOffset = d.width / 2 - width / 2;
      yOffset = d.height / 2 - height / 2;
    }
    Point p = frame.getLocation();
    p.translate(xOffset, yOffset);
    setLocation(p);
                   
    setSize(width, height);
    show();

  }
   
  public void setMessage(String s) {
    message.setText(s);
    setVisible(true);
  }
   
  public void actionPerformed(ActionEvent e) {
    setVisible(false);
  }
   
  public static void main(String args[]) {
    // pretty simple test
    Frame f = new Frame("Warning Dialog Test");
    f.setSize(600, 800);
    f.show();
    String s = "A very long string to test things and such";
    WarningDialog wd1 = new WarningDialog(f, "Test WarningDialog", s);
    wd1.setMessage("Test WarningDialog");
    System.exit(0);
                   
  }
   
  // local variables
  private Panel panel;
  private int width = 300;
  private int height = 125;
  private TextArea message;
  private Button okButton;

}
