c
c this common block contains information and storage for the homogenization
c calculations used in the the simulator. note the file homog_common.h contains
c the matrix information determined in the homogenization process.
c
c General comments about the data structures:
c
c 1. the arrays are one-dimensional for all cases. the arrays are ordered
c    lexicographically in the spatial grid.
c
c 2. The description of the variables is given below.
c
c 3. the parameter statements are included in this file to keep things a little
c    easier in terms of coding subroutines.
c
c 4. this common block MUST appear before all other permeability common blocks
c    like homog_common so that the parameter statement can be loaded for
c    setting up the array lengths
c
c homogenization variables
c
c   iavgtyp - the type of averaging to use
c             iavgtyp=1; homogenization (default)
c             iavgtyp=2; arithmetic average
c             iavgtyp=3; harmonic average
c             iavgtyp=4; geometric average
c   nxhom - the number of homogenization blocks in the first coordinate
c           direction
c   nyhom - the number of homogenization blocks in the second coordinate
c           direction
c   nzhom - the number of homogenization blocks in the third coordinate
c           direction
c   nxhref - the number of computational refinements in the first coordinate
c            direction
c   nyhref - the number of computational refinements in the second coordinate
c            direction
c   nzhref - the number of computational refinements in the third coordinate
c            direction
c
      common /hom/ iavgtyp,nxhom,nyhom,nzhom,nxhref,nyhref,nzhref
