c
c this common block contains information about the homogenization process for
c the porous media
c
c parameters
c
c   nodhom - maximum number of homogeneous nodes allowed in the system
c   nodhet - maximum number of heterogeneous nodes allowed in the system
c   nxhom - number of homogenized grid blocks in the first coordinate direction
c   nyhom - number of homogenized grid blocks in the second coordinate direction
c   nzhom - number of homogenized grid blocks in the third coordinate direction
c   nnhom - number of homogenized blocks
c
c      parameter(nodhom=100000,nodhet=100000,nxhmax=100,nyhmax=100
c     1,nzhmax=100)
      parameter(nodhom=50000,nodhet=50000,nxhmax=50,nyhmax=50
     1,nzhmax=50)
c
c matrix storage
c
c   ha - matrix generated in solving the ellptic problems in the homogenization
c   hx - the solution values at the nodes returned after the solution of the
c        system of equations - these are used to compute the homogenized
c        values or perturbation series values.
c   hrhs - right hand side generated in solving the ellptic problems in the
c          homogenization
c   h0 - the initial guess at the solution of the linear system of equations
c        passed to the iterative solver
c
      common /homog/ ha(nodhom,27),hx(nodhom,3),hrhs(nodhom,3)
     1,h0(nodhom)
c
c mask vector for the cells
c
c   ibith - bit vector used to map over the cells for the homogenization
c
     1,ibith(nodhet)
