c
c this common block contains information about the sources and sinks. the
c values are:
c
c  problem definition variables - (input)
c
c   nmbrsrc - the number of sources and sinks in the simulation
c   isrcsnk - array containng the type of source/sink
c          injection or production. the second argument of the array
c          denotes whther the point is a source or sink.
c          source/sink designation
c            isrcsnk(k,2) = 1; the point is a source
c            isrcsnk(k,2) = -1; the point is a sink
c          source/sink type designation
c            isrcsnk(k,1) = 1; constant flux rate specified at the point
c            isrcsnk(k,1) = 2; constant pressure specified at the point
c            isrcsnk(k,1) = 3; time dependent flux rate at the point
c            isrcsnk(k,1) = 4; time dependent pressure specified at the point
c            isrcsnk(k,1) = 5; constant flux rate - line source/sink
c            isrcsnk(k,1) = 6; constant pressure - line source/sink
c            isrcsnk(k,1) = 7; time dependent flux rate - line source/sink
c            isrcsnk(k,1) = 8; time dependent pressure - line source/sink
c   qsrcsnk - injection/production of the phases at the sources and strengths
c             these values are always nonnegative since the array of types will
c             take care of the sign in the simulator.
c   xsrc - the x coordinate location of the source/sink - the second dimmension
c          is for the case where the source/sink is a line source/sink
c   ysrc - the y coordinate location of the source/sink - the second dimmension
c          is for the case where the source/sink is a line source/sink
c   zsrc - the z coordinate location of the source/sink - the second dimmension
c          is for the case where the source/sink is a line source/sink
c   srsnkfl - array of file names for the input from time dependent problems
c   nsrsnfl - nunmber of characters in the file name srsnkfl
c
c  interface variables between problem definition and computational grid
c
c   isrcmap - interger array containing the beginning index in the computational
c             source/sink array associate with the given problem source/sink
c   srcwt - array of weights to use in distributing the problem source or
c           sink onto the grid blocks
c
c  computational grid variables
c
c   nbrscmp - the number of computational sources
c   qcmpsrc - this is the array of value to be used in the simulator on the
c             computational grid which are copmuted in the routine srcvals
c             before each time step through the simulator
c   qcmpold - the copmutational flow values from the previous time level
c   indsrc - the index location of the source/sink  with respect to the
c            pressure/saturation nodes
c   srcbvol - volume of the source/sink blocks
c
c the factor of 8 in the dimensioning of the computational array is due to the
c fact that any given source or sink could be split up over a number of cells.
c for the point variety the maximum number is 8 cells. however, for the line
c sources and sinks there is no good way to tell. thus the factor 8 is used.
c
c problem definition infirmation first
c ------------------------------------
c
      common /srcsnk/ nmbrsrc,isrcsnk(nptsrc,2),qsrcsnk(nptsrc,nph+1)
c     1,xsrc(nptsrc,2),ysrc(nptsrc,2),zsrc(nptsrc,2),srsnkfl(nptsrc)
     1,xsrc(nptsrc,2),ysrc(nptsrc,2),zsrc(nptsrc,2),srsnkfl
     1,nsrsnfl(nptsrc)
c
c mapping information between the problem and computational grid
c --------------------------------------------------------------
c
     1,isrcmap(nptsrc+1),srcwt(8*nptsrc)
c
c computational stuff
c -------------------
c
     1,nbrscmp,qcmpsrc(8*nptsrc,nph+1),qcmpold(8*nptsrc,nph+1)
     1,indsrc(8*nptsrc),srcbvol(8*nptsrc)
      character*20 srsnkfl(nptsrc)
