c
c this common block contains the time and time step information as well
c as information about times to print out results. the values are:
c
c   time - actual time in the simulation ( in days )
c   dtmax - the maximum allowable time step for the simulation
c   fintim - final time in the simulation
c   tstep - the current time step in the simulator
c   itimtyp - determine the type of time stepping to use
c             0 - constant time stepping
c             1 - the old 2% thing
c             2 - characteristic time stepping
c   pvinj - injection value in pore volumes
c   pvprd - production value in pore volumes
c   porvol - the total pore volumes to be injected
c   nplt - the number of plots after the initial time
c   iplt - pointer for the array of output times
c   pvplt - times in pore volumes injected to output results - use iotype=0
c           this requires that an array values be input
c   timplt - actual times output array - evenly spaced between time(1) and
c            fintim - use iotype > 0, where itimtyp=number of evenly
c            spaced points.
c   isimend - flag to tell the simulator to return to calling routine
c
c actual time variables
c ---------------------
c
      common /tmstp/ time(nplots),dtmax,fintim,tstep,itimtyp
c
c injection time variables
c ------------------------
c
     1,pvinj(nplots),pvprd(nplots),porvol
c
c output determination variables
c ------------------------------
c
     1,nplt,iplt,timplt(nplots),pvplt(nplots)
c
c end of simulation flag
c ----------------------
c
     1,isimend
