C23456789012345678901234567890123456789012345678901234567890123456789012
C       10        20        30        40        50        60        70
      PROGRAM postpr
C     ##############
C

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementF.h'
      INCLUDE 'gloGisementG.h'
      INCLUDE 'gloTableauxF.h'
      INCLUDE 'gloTableauxG.h'

      CHARACTER*128 title,str
      CHARACTER*128 outIndxG,outEntreG,outPcG,outpermG
      CHARACTER*128 outFonsG,outPhiG
C      CHARACTER*128 outDims,outIndxFG,outSIrG,outIndxFD

      INTEGER ii,jj,IndxFG(NUMMF),IndxFDFG(NUMMF),DimFon,i,j
      INTEGER Fl(NUMMF),IndxFD(NUMMG),FtoG,iv
      INTEGER Iwel(6),Jwel(6),K1wel(6),K2wel(6) ! coordonnees de puits
      INTEGER k,l,ordF
      REAL  Acorr,Bcorr,seuil
C  --------------------
      INTEGER CallCont
      COMMON /notImpotrant/ CallCont
 
      CallCont=0 ! compteur de nombre d'appel de la routine 
                 ! ecriHOMOG (pour affichage des WARNINGS).
C  --------------------

C -------------------------------------------------------------------------------

      DO i=1,DimF   !  For each fine grid block i, Fl(i)=0 means set permeability 
         Fl(i)=0    !  value to homogenized one; Fl(i)=1 means keep the original
      END DO        !  value from the heterogeneous field. Function lireWells
                    !  would initialize Fl() such tha original values are kept in
                    !  homogenized field around the wells. All that is now removed
                    !  and we do not keep any original value in homogenized field. 
C---------------------------------------------------------------------------------

C >>> Lecture de parametre de la ligne de commande
C     (nom de fichier d'entre et -only flag)

      CALL Init()

C >>> Lecture du fichier d'entre.
C  =========== title is now used as directory name for permeability map

      CALL EntreDon(title,Acorr,Bcorr,seuil)
 
C >>> Here we set our own temporary directory to keep intermediate data
C >>> The name DirTmp is composed in EnreDon from a number of coarse grid
C >>> blocks 

      i=index(DirTmp,' ')-1
C         1         2         3         4         5         6         7  
C23456789012345678901234567890123456789012345678901234567890123456789012
      CALL SYSTEM("if [ ! -d "//DirTmp(1:i)//" ] ; then echo\"Directory 
     >"//DirTmp(1:i)//" does not existe.\" ; fi")



C >>> Les noms de fichiers de sortie (donnees sur maillage grossier)

      ii=index(DirTmp,' ')-1
      outEntreG = DirTmp(1:ii)//'EntreG '
      outIndxG  = DirTmp(1:ii)//'IndxG  '
      outFonsG  = DirTmp(1:ii)//'FonsG  '
      outPcG    = DirTmp(1:ii)//'PcG    '
      outPhiG   = DirTmp(1:ii)//'PhiG   '
      outpermG  = DirTmp(1:ii)//'PermG  '


C >>> Lecture des permeabilites absolues horizontales,
C     les porosites etc. sur le maillage fin.
C                               ------------

      CALL lirePA(phi,inphi)

      DO k=1,diml(3)
      DO j=1,diml(2)
      DO i=1,diml(1)
         l=ordF(i,j,k)
         dz(l)=longfz(k)
      END DO
      END DO
      END DO

C >>> FIN de la lecture des donnees sur le maillage fin.
C     -------------------------------------------------
      

C >>> Lecture de tableaux des fonctions sur le maillage fin.
C                                              ------------

      CALL lireTabl()
 
C >>> Lecture des  valeurs homogeneises
C     ---------------------------------

      CALL lirePoroG(outPhiG,PhiG) ! lire porosites homogeneises
      CALL ecriPoroG(title,PhiG)   !  write hom. porosity 

      ndfg=DimG                                ! no of tables = no of grid blocks
      CALL lireEntreG(outEntreG,DimG,entreG)   ! Lecture de 
      CALL lireIndxG(outIndxG,DimG,IndxG)      ! Pc homogeneises
      CALL lirePcG(outPcG)                     !

      CALL lirePermG(title)         ! lire perms homogeneises
      CALL calInvPer()              ! l'invers de perms si necessaire

      CALL makeGFunctions()            ! lire et genere les fonctions 
                                       ! homogeneises
#ifdef DBG
      CALL FGSort(title,outFonsG)     ! Sortie de fonctions
#endif

C >>> We don't give satnum field since all homogenized data are given on
C >>> coarse grid (satnum is trivial on coares grid) and we wan't give 
C >>> homogenized field on fine grid. 
C     dimFon=DimG
C     DO i=1,DimF
C           j=FtoG(i)
C           IndxFG(i)=IndxG(j)
C     END DO
C     CALL ecriSatnumG(Fl,IndxFG,dimFon,title)

      CALL ecriSwofG  (DimG,pcflag,title)
      CALL ecriSatnumG (IndxG, title)      ! give this although is trivial.


#ifndef DBG
      CALL CleanTmpFolders()
#endif
      
      PRINT *,' Done (pospro).'
      END
