      SUBROUTINE Init()
C     ################
C >>> Lecture des parametres qui sont passes au programme. 
C     On accept seulement un parametre et c'est le nom du 
C     fichier avec donnees d'entrees.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'flags.h'

      INTEGER noofargs,i,j,k,io,IARGC,index
      CHARACTER*128 only


C >>> Initialisation de toutes les chaines de caracteres.
C     Probablement pas necesaire.

      DO i=1,128
       prog(i:i)       =' '
       input(i:i)      =' '
       outphi(i:i)     =' '
       inphi(i:i)      =' '
       swof(i:i)       =' '
       satnm(i:i)      =' '
       basew(i:i)      =' '
       baseo(i:i)      =' '
       DirTmp(i:i)     =' '
      END DO

      noofargs=IARGC()
      CALL getarg(0,prog)

      IF(noofargs.EQ.1) THEN
        CALL getarg(1,input)
      ELSE
        i=index(prog,' ')-1
        PRINT *,'@ERROR: expecting input file name as a parameter.'
        PRINT *,'Usage: '//prog(1:i)//' input_file'
        CALL exit(-1)
      END IF

#ifdef DBG
      zz=99
      i=index(prog,' ')-1
      OPEN(unit=zz,file=prog(1:i)//'.dbg',err=109,iostat=io)
      WRITE(zz,*) '@DBG: Init       (sorti)'
      PRINT *,'>>> Degugging output goes to ',prog(1:i)//'.dbg'
#endif

      zx=6 ! stdout


      RETURN
109   CALL openerr(io,prog)
      END

      SUBROUTINE EntreDon(title, Acorr,Bcorr,seuil)
C     #############################################

C >>> Lecture du fichier d'entre.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'

      INTEGER compte,io,ax,ay,az,i,ii,i_tmp
C     INTEGER skip
      LOGICAL check
      REAL  Acorr,Bcorr,seuil

      CHARACTER*128 title ! le titre de jeu de donnees

      INTEGER j1,j2,j3
      CHARACTER*3 ch1,ch2,ch3,int2ch

#ifdef DBG
      WRITE(zz,*) '@DBG: EntreDon   (enter)'
#endif

      ii=index(input,' ')
      OPEN(12,file=input(1:ii),err=100,iostat=io,status='old')
      WRITE(zx,*) '>>> Reading input file  ',input(1:ii)
#ifdef DBG
      WRITE(zz,*) "@DBG Input file  ",input(1:ii)
#endif

C  ================== title is now used as directory name for premeability map.
      compte=0
      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) title                        !  1  title   

#ifdef DBG
      WRITE(zz,*) '@DBG output: Input data.'
      WRITE(zz,*) '@DBG title:'
      i=index(title,' ')
      WRITE(zz,*) '@DBG ',title(1:i)
#endif

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) dims(1),dims(2),dims(3)      ! 2 dims

      check=(dims(1).GE.1).AND.(dims(1).LE.MAXFX).AND.
     >      (dims(2).GE.1).AND.(dims(2).LE.MAXFY).AND.
     >      (dims(3).GE.1).AND.(dims(3).LE.MAXFZ)

      IF(.NOT.check) THEN
        WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
        WRITE(zx,*) '@ERROR: line ',compte
        WRITE(zx,*) '@ERROR: dims out of limits (see params.h).'
        WRITE(zx,*) '@ERROR: dims(1)=',dims(1)                     
        WRITE(zx,*) '@ERROR: dims(2)=',dims(2)                     
        WRITE(zx,*) '@ERROR: dims(3)=',dims(3)                     
        WRITE(zx,*) '@ERROR: MAXFX  =',MAXFX                         
        WRITE(zx,*) '@ERROR: MAXFY  =',MAXFY                         
        WRITE(zx,*) '@ERROR: MAXFZ  =',MAXFZ                         
        CALL exit(-1)
      END IF

#ifdef DBG
       WRITE(zz,*) '@DBG dims(1)=',dims(1),' dims(2)=',dims(2),
     >' dims(3)=',dims(3)
#endif

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (longfx(i),i=1,dims(1))      ! 3 longfx
      
#ifdef DBG
       WRITE(zz,*) '@DBG longfx= ',(longfx(i),i=1,dims(1))
#endif
      DO i=1,dims(1)
       IF(longfx(i).LE.0.0) THEN
         WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
         WRITE(zx,*) '@ERROR: line ',compte
         WRITE(zx,*) '@ERROR: longfx <= 0.0 .'
        CALL exit(-1)
       END IF
      END DO

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (longfy(i),i=1,dims(2))     ! 4 longfy
      
#ifdef DBG
       WRITE(zz,*) '@DBG longfy= ',(longfy(i),i=1,dims(2))
#endif
      DO i=1,dims(2)
       IF(longfy(i).LE.0.0) THEN
         WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
         WRITE(zx,*) '@ERROR: line ',compte
         WRITE(zx,*) '@ERROR: longfy <= 0.0 .'
        CALL exit(-1)
       END IF
      END DO

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (longfz(i),i=1,dims(3))     ! 5  longfz
      
#ifdef DBG
       WRITE(zz,*) '@DBG longfz= ',(longfz(i),i=1,dims(3))
#endif
      DO i=1,dims(3)
       IF(longfz(i).LE.0.0) THEN
         WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
         WRITE(zx,*) '@ERROR: line ',compte
         WRITE(zx,*) '@ERROR: longfz <= 0.0 .'
        CALL exit(-1)
       END IF
      END DO

C ------------------------------------------------------------------

      diml(1)=dims(1)    ! on extait toujours la boite entiere
      diml(2)=dims(2)    ! 10/03/1999
      diml(3)=dims(3)

      DimF=diml(1)*diml(2)*diml(3)
C ------------------------------------------------------------------


#ifdef DBG
      WRITE(zz,*) '@DBG DimF (dimension de domaine extraite)= ',DimF
#endif

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) npp                       ! 6 npp

#ifdef DBG
       WRITE(zz,*) '@DBG npp   = ',npp    
#endif

      check=(npp.GE.1).AND.(npp.LE.DIMFONC-1)
      IF(.NOT.check) THEN
        WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
        WRITE(zx,*) '@ERROR: line ',compte
        WRITE(zx,*) '@ERROR: npp out of bounds  (see  params.h).'
        WRITE(zx,*) '@ERROR: npp =',npp,' DIMFONC=',DIMFONC        
        CALL exit(-1)
      END IF

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (ngros(i),i=1,3)          ! 7 ngros

      check=(ngros(1).GE.1).AND.(ngros(2).GE.1).AND.(ngros(3).GE.1).AND.
     >      (ngros(1).LE.diml(1)).AND.(ngros(2).LE.diml(2)).AND.
     >      (ngros(3).LE.diml(3))

      IF(.NOT.check) THEN
        WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
        WRITE(zx,*) '@ERROR: line ',compte
        WRITE(zx,*) '@ERROR: ngros out of bounds.'
        WRITE(zx,*) '@ERROR: ngros(1)=',ngros(1)     
        WRITE(zx,*) '@ERROR: ngros(2)=',ngros(2)     
        WRITE(zx,*) '@ERROR: ngros(3)=',ngros(3)     
        CALL exit(-1)
      END IF

      DimG=ngros(1)*ngros(2)*ngros(3)
#ifdef DBG
      WRITE(zz,*) '@DBG DimG (dimension de domaine grossiere)= ',DimG
#endif

#ifdef DBG
       WRITE(zz,*) '@DBG ngros = ',(ngros(i),i=1,3)
#endif

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (agregx(i),i=1,ngros(1))   ! 8 agregx

#ifdef DBG
       WRITE(zz,*) '@DBG agregx= ',(agregx(i),i=1,ngros(1))
#endif

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (agregy(i),i=1,ngros(2))    ! 9 agregx

#ifdef DBG
       WRITE(zz,*) '@DBG agregy= ',(agregy(i),i=1,ngros(2))
#endif

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) (agregz(i),i=1,ngros(3))     ! 10 agregx

#ifdef DBG
       WRITE(zz,*) '@DBG agregz= ',(agregz(i),i=1,ngros(3))
#endif

      DO i=1,ngros(1)
        IF(agregx(i).LT.1) THEN
         WRITE(zx,*) '@ERROR: agregx < 1! Bye.'
         CALL exit(-1)
        END IF
      END DO
      DO i=1,ngros(2)
        IF(agregy(i).LT.1) THEN
         WRITE(zx,*) '@ERROR: agregy < 1! Bye.'
         CALL exit(-1)
        END IF
      END DO
      DO i=1,ngros(3)
        IF(agregz(i).LT.1) THEN
         WRITE(zx,*) '@ERROR: agregz < 1! Bye.'
         CALL exit(-1)
        END IF
      END DO

      ax=0
      ay=0
      az=0
      DO 76 i=1,ngros(1)
76     ax=ax+agregx(i)      
      DO 77 i=1,ngros(2)
77     ay=ay+agregy(i)      
      DO 78 i=1,ngros(3)
78     az=az+agregz(i)      

      IF((ax.NE.dims(1)).OR.(ay.NE.dims(2)).OR.(az.NE.dims(3))) THEN
         WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
         WRITE(zx,*) '@ERROR: lines ',compte-2,compte-1,compte
         WRITE(zx,*) '@ERROR: Wrong number of coefficients. ' 
         CALL exit(-1)
      END IF

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) swof                       ! 11 complet 

      IF(swof(1:7).EQ.'COMPLET') THEN          ! way of calculation of relative perms.
        complet=1                              ! we have to neglect extradiagonal terms 
      ELSE IF(swof(1:9).EQ.'UNCOMPLET') THEN   ! if we want to have fuctions
        complet=0                          
      ELSE
         WRITE(zx,*) '@ERROR: while reading file ',input(1:ii)
         WRITE(zx,*) '@ERROR: line ',compte
         WRITE(zx,*) '@ERROR: unknown option: ',swof(1:i) 
         CALL exit(-1)
      END IF
#ifdef DBG
       IF(complet.EQ.1) THEN
       WRITE(zz,*) '@DBG complet  = COMPLET'
       ELSE
       WRITE(zz,*) '@DBG complet  = UNCOMPLET'
       END IF
#endif
C >>> Noms des fichiers

C --------------------------------------------------
C  ================  mladen 10/12/2002   \/ unqnown escape sequence

       ch1=int2ch(ngros(1))
       ch2=int2ch(ngros(2))
       ch3=int2ch(ngros(3))
       j1=index(ch1,' ')-1
       j2=index(ch2,' ')-1
       j3=index(ch3,' ')-1
       DirTmp='__'//ch1(1:j1)//'x'//ch2(1:j2)//'x'//ch3(1:j3)//'__/ '

#ifdef DBG
       i=index(DirTmp,' ')
       WRITE(zz,*) '@DBG DirTmp= ',DirTmp(1:i)
#endif
C --------------------------------------------------

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) inphi                       ! 12

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) swof                        ! 13

      CALL avance(12,'#',compte)
      READ(12,*,end=200,err=200) satnm                       ! 14

      i=index(DirTmp,' ')-1
      outphi    =  DirTmp(1:i)//'phi'   

      i=index(title,' ')-1
      basew     =  title(1:i)//'_rw'     
      baseo     =  title(1:i)//'_ro'     

#ifdef DBG
       i=index(inphi,' ')
       WRITE(zz,*) '@DBG inphi    = ',inphi(1:i)
       i=index(swof,' ')
       WRITE(zz,*) '@DBG swof     = ',swof(1:i)
       i=index(satnm,' ')
       WRITE(zz,*) '@DBG satnm    = ',satnm(1:i)
       i=index(outphi,' ')
       WRITE(zz,*) '@DBG outphi   = ',outphi(1:i)
       i=index(basew,' ')
       WRITE(zz,*) '@DBG basew    = ',basew(1:i)
       i=index(baseo,' ')
       WRITE(zz,*) '@DBG baseo    = ',baseo(1:i)
#endif
       CALL avance(12,'#',compte)
C      READ(12,*,end=200,err=200) pcflag                    ! 15 
       READ(12,*) pcflag   

#ifdef DBG
       IF(pcflag.EQ.1) THEN
       WRITE(zz,*) '@DBG pcflag   = PUT PC TO ZERO'
       ELSE
       WRITE(zz,*) '@DBG pcflag   = USE PC'
       END IF
#endif

      CLOSE(12)
       
C
#ifdef DBG
      WRITE(zz,*) "@DBG output: End of input data."
#endif

      RETURN
100   CALL openerr(io,input)
200   WRITE(zx,*) '@ERROR: EntreDon: while reading file ',input(1:ii)
      WRITE(zx,*) '@ERROR: EntreDon: line ',compte
      CALL exit(-1)
      END


      SUBROUTINE ecrireR(nom,Dim,vector,title)
C     ########################################
C     Ecrire champs reele.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INTEGER ii,i,Dim,io
      CHARACTER*128 nom,title
      CHARACTER*9 datum      
      REAL vector(*)

#ifdef DBG
      WRITE(zz,*) '@DBG: ecrireR    (enter)'
#endif
      ii=index(nom,' ')-1
      OPEN(12,file=nom(1:ii),err=400,iostat=io)
      PRINT *,'>>> Ecriture de ',nom(1:ii)

C  ====  changing DATE() to DATE_Y2KBUG() to avoid warnings
      CALL DATE_Y2KBUG(datum)
      i=index(title,' ')
      WRITE(12,*) title(1:i),datum
      DO i=1,Dim
        WRITE(12,*,err=200) vector(i)
      END DO
      CLOSE(12)
      RETURN
400   CALL openerr(io,nom)
200   PRINT *,'@ERROR: while writing to file ',nom(1:ii)
      PRINT *,'@ERROR: line ',i
      CALL exit(-1)
      END

      SUBROUTINE ecrireI(nom,Dim,vector,title)
C     ########################################
C     Ecrire champs reele.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INTEGER ii,i,Dim,io
      CHARACTER*128 nom,title
      CHARACTER*9 datum      
      INTEGER vector(*)

#ifdef DBG
      WRITE(zz,*) '@DBG: ecrireI    (enter)'
#endif
      ii=index(nom,' ')-1
      OPEN(12,file=nom(1:ii),err=400,iostat=io)
      PRINT *,'>>> Ecriture de ',nom(1:ii)

      CALL DATE_Y2KBUG(datum)
      i=index(title,' ')
      WRITE(12,*) title(1:i),datum
      DO i=1,Dim
        WRITE(12,*,err=200) vector(i)
      END DO
      CLOSE(12)
      RETURN
400   CALL openerr(io,nom)
200   PRINT *,'@ERROR: while writing to file  ',nom(1:ii)
      PRINT *,'@ERROR: line ',i
      CALL exit(-1)
      END

      SUBROUTINE ecrirePcG(entreG,SG,PCTG,title,nom,PhiH)
C     ###################################################

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      REAL SG(DIMTABG),PCTG(DIMTABG),PhiH(NUMMG)
      INTEGER entreG(NUMTABG+1)
      INTEGER i,j,ii,io
      CHARACTER*128 title,intFich
      CHARACTER*3 countCh
      CHARACTER*9 datum      
      CHARACTER*128 nom   

#ifdef DBG
      WRITE(zz,*) '@DBG: ecrirePcG  (enter)'
#endif

      ii=index(nom,' ')-1
      OPEN(12,file=nom(1:ii),err=400,iostat=io)
      PRINT *,'>>> Writing to ',nom(1:ii)

      CALL DATE_Y2KBUG(datum)
      i=index(title,' ')
      WRITE(12,*) title(1:i),datum

      DO 31 j=1,DimG

       WRITE(unit=intFich,fmt='(i3)') j
       READ(unit=intFich,fmt='(a3)') countCh
       IF(countCh(1:1).EQ.' ') countCh(1:1)='0'
       IF(countCh(2:2).EQ.' ') countCh(2:2)='0'

       IF(PhiH(j).EQ.0.0) THEN
         WRITE(12,*) 'PcG'//countCh,' maille morte'
       ELSE
         WRITE(12,*) 'PcG'//countCh
       ENDIF
       DO 31 i=entreG(j),entreG(j+1)-1
        WRITE(12,'(G12.4,2x,G12.4)',err=200) SG(i),PCTG(i)
31     CONTINUE
      CLOSE(12)
      RETURN
400   CALL openerr(io,nom)
200   PRINT *,'@ERROR: while writing to file ',nom(1:ii)
      PRINT *,'@ERROR: ligne ',i
      CALL exit(-1)
      END

      SUBROUTINE lireEntreG(nom,dimen,entreG)
C     ################################

      IMPLICIT NONE
      INCLUDE 'params.h'
C      INCLUDE 'dimensions.h'
C      INCLUDE 'gloTableauxG.h'

      INTEGER entreG(NUMTABG+1)
      INTEGER ii,i,io,dimen
      CHARACTER*128 nom

#ifdef DBG
      WRITE(zz,*) '@DBG: lireEntreG (enter)'
#endif
      ii=index(nom,' ')-1
      OPEN(12,file=nom(1:ii),err=400,iostat=io,status='old')
      PRINT *,'>>> Reading file  ',nom(1:ii)

      READ(12,*)
      DO i=1,dimen+1
        READ(12,*,err=200) entreG(i)
      END DO
      CLOSE(12)
C      ndfg=dimen
      RETURN
400   CALL openerr(io,nom)
200   PRINT *,'@ERROR: while reading file  ',nom(1:ii)
      PRINT *,'@ERROR: line ',i
      CALL exit(-1)
      END

      SUBROUTINE lireIndxG(nom,dimen,IndxG)
C     ####################################
C         dimen must be DimG
C         This is sily sine the field read is 1,2,3,...
      IMPLICIT NONE
      INCLUDE 'params.h'
C      INCLUDE 'dimensions.h'
C      INCLUDE 'gloTableauxG.h'

      INTEGER ii,i,io
      INTEGER IndxG(NUMMG),dimen
      CHARACTER*128 nom

#ifdef DBG
      WRITE(zz,*) '@DBG: lireIndxG  (enter)'
#endif
      ii=index(nom,' ')
      OPEN(12,file=nom(1:ii),err=400,iostat=io,status='old')
      PRINT *,'>>> Reading file  ',nom(1:ii)

      READ(12,*)
      DO i=1,dimen
        READ(12,*,err=200) IndxG(i)
      END DO
      CLOSE(12)
      RETURN
400   CALL openerr(io,nom)
200   PRINT *,'@ERROR: while reading file  ',nom(1:ii)
      PRINT *,'@ERROR: line ',i
      CALL exit(-1)
      END

      SUBROUTINE lirePcG(nom)
C     ####################

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'gloTableauxG.h'

      INTEGER i,j,ii,io
      CHARACTER*128 nom

#ifdef DBG
      WRITE(zz,*) '@DBG: lirePcG  (enter)'
#endif
      ii=index(nom,' ')
      OPEN(12,file=nom(1:ii),err=400,iostat=io)
      PRINT *,'>>> Reading file  ',nom(1:ii)

      READ(12,*)
      DO 31 j=1,DimG
      READ(12,*)
      DO 31 i=entreG(j),entreG(j+1)-1
        READ(12,*,err=200) SG(i),PCTG(i)
31    CONTINUE
      CLOSE(12)
      RETURN
400   CALL openerr(io,nom)
200   PRINT *,'@ERROR: while reading file  ',nom(1:ii)
      PRINT *,'@ERROR: line ',i
      CALL exit(-1)
      END


      SUBROUTINE makeGFunctions()
C     ############################
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloTableauxG.h'
      INCLUDE 'gloGisementG.h'

      REAL x,a(DimG),b(DimG)

      INTEGER i,k,l,count,ii,io

      CHARACTER*2  nCh,int2ch
      CHARACTER*3 countCh,convrt
      CHARACTER*128 file_w, file_o

#ifdef DBG
      WRITE(zz,*) '@DBG: makeGFunctions (enter)'
#endif
      
C >>> Convert le numero de fichire (count) dans le caracteres.

      DO 100 count=1,npp-1

C >>> Compose le nom du fichier de K kr(S) et ouvert le.

      CALL hom_file_name(basew,count,file_w)
      ii=index(file_w,' ')-1
      OPEN(12,file=file_w(1:ii),err=400,iostat=io, status='old')
      PRINT *,'>>> Reading ',file_w(1:ii)

      READ(12,*) i  ! check with ngros
      IF(i .NE. ngros(1)) THEN
         WRITE(*,*) '>> WARNING1 (lireFon) Incorect output file.'
      END IF
      READ(12,*) i
      IF(i .NE. ngros(2)) THEN
         WRITE(*,*) '>> WARNING1 (lireFon) Incorect output file.'
      END IF
      READ(12,*) i
      IF(i .NE. ngros(3)) THEN
         WRITE(*,*) '>> WARNING1 (lireFon) Incorect output file.'
      END IF

      CALL hom_file_name(baseo,count,file_o)
      ii=index(file_o,' ')-1
      OPEN(13,file=file_o(1:ii),err=500,iostat=io, status='old')
      PRINT *,'>>> Reading ',file_o(1:ii)
      READ(13,*) i  ! check with ngros
      IF(i .NE. ngros(1)) THEN
         WRITE(*,*) '>> WARNING1 (lireFon) Incorect output file.'
      END IF
      READ(13,*) i
      IF(i .NE. ngros(2)) THEN
         WRITE(*,*) '>> WARNING1 (lireFon) Incorect output file.'
      END IF
      READ(13,*) i
      IF(i .NE. ngros(3)) THEN
         WRITE(*,*) '>> WARNING1 (lireFon) Incorect output file.'
      END IF

C >>> Lecture des donnees dans trois colonnes d'HOMOG

         READ(12,*) (a(i),i=1,DimG)   ! k_xx
         READ(13,*) (b(i),i=1,DimG)
         DO i=1,DimG
          k=entreG(IndxG(i))
          l=k+count
          IF(complet.EQ.0) THEN
           KRWTG1(l)=a(i)/pGx(i) 
          ELSE
           KRWTG1(l)=a(i)*ipGx(i) 
          END IF
          l=l-1
          IF(complet.EQ.0) THEN
           KROTG1(l)=b(i)/pGx(i) 
          ELSE
           KROTG1(l)=b(i)*ipGx(i) 
          END IF
         END DO

         READ(12,*) (a(i),i=1,DimG)  ! k_xy
         READ(13,*) (b(i),i=1,DimG)


         READ(12,*) (a(i),i=1,DimG)  ! k_xz
         READ(13,*) (b(i),i=1,DimG)

         READ(12,*) (a(i),i=1,DimG)  ! k_yx
         READ(13,*) (b(i),i=1,DimG)

         READ(12,*) (a(i),i=1,DimG)  ! k_yy
         READ(13,*) (b(i),i=1,DimG)
         DO i=1,DimG
          k=entreG(IndxG(i))
          l=k+count
          IF(complet.EQ.0) THEN
           KRWTG2(l)=a(i)/pGy(i)
          ELSE
           KRWTG2(l)=a(i)*ipGy(i)
          END IF
          l=l-1
          IF(complet.EQ.0) THEN
           KROTG2(l)=b(i)/pGy(i)
          ELSE
           KROTG2(l)=b(i)*ipGy(i)
          END IF
         END DO

         READ(12,*) (a(i),i=1,DimG)  ! k_yz
         READ(13,*) (b(i),i=1,DimG)

         READ(12,*) (a(i),i=1,DimG)  ! k_zx
         READ(13,*) (b(i),i=1,DimG)

         READ(12,*) (a(i),i=1,DimG)  ! k_zy
         READ(13,*) (b(i),i=1,DimG)

         READ(12,*) (a(i),i=1,DimG)  ! k_zz
         READ(13,*) (b(i),i=1,DimG)
         DO i=1,DimG
          k=entreG(IndxG(i))
          l=k+count
          IF(complet.EQ.0) THEN
           KRWTG3(l)=a(i)/pGz(i)
          ELSE
           KRWTG3(l)=a(i)*ipGz(i)
          END IF
          l=l-1
          IF(complet.EQ.0) THEN
           KROTG3(l)=b(i)/pGz(i)
          ELSE
           KROTG3(l)=b(i)*ipGz(i)
          END IF
         END DO

        CLOSE(12)
        CLOSE(13)
C  ====================================  Now we want to delete the two 
C                                        files that we have used, but only in 
C                                        non debugging mode.
100   CONTINUE
        
      DO i=1,DimG
       l=entreG(i)
       KRWTG1(l)=0.0 
       KRWTG2(l)=0.0 
       KRWTG3(l)=0.0 
       l=l+npp-1
       KROTG1(l)=0.0
       KROTG2(l)=0.0
       KROTG3(l)=0.0
      END DO
      RETURN
400   CALL openerr(io,file_w(1:ii))
500   CALL openerr(io,file_o(1:ii))
      END

      SUBROUTINE lirePermG(dir)
C     #####################
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementG.h'

      CHARACTER*128 file,dir
      REAL x
      INTEGER i,ii,io

#ifdef DBG
      WRITE(zz,*) '@DBG: lirePermG  (enter)'
#endif
      
      CALL hom_file_name(dir,0,file)
      ii=index(file,' ')
      OPEN(12,file=file(1:ii),iostat=io,err=400,status='old')
      PRINT *,'>>> Lecture de ',file(1:ii)


C ===========  read Joe's format
      READ(12,'(I5)') i   ! ngros 1,2,3 In future read this and make a check.!!!!!!
      IF(i .NE. ngros(1)) THEN
          WRITE(*,*) '>> WARNING1 (lirePerm) Incorect dimensions.'
      END IF
C      PRINT *, i
      READ(12,'(I5)') i
      IF(i .NE. ngros(2)) THEN
          WRITE(*,*) '>> WARNING2 (lirePerm) Incorect dimensions.'
      END IF
C      PRINT *, i
      READ(12,'(I5)') i
      IF(i .NE. ngros(3)) THEN
          WRITE(*,*) '>> WARNING3 (lirePerm) Incorect dimensions.'
      END IF
C      PRINT *, i
      WRITE(*,*) 'DimG= ', DimG 
      READ(12,*) (pGx(i), i=1,DimG)
C      WRITE(*,*) (pGx(i), i=1,DimG) 

      READ(12,*) (pGxy(i), i=1,DimG)
C      WRITE(*,*) (pGxy(i), i=1,DimG) 

      READ(12,*) (pGxz(i), i=1,DimG)
C      WRITE(*,*) (pGxz(i), i=1,DimG)

      READ(12,*) (pGxy(i), i=1,DimG)  ! we use symmetry
C      WRITE(*,*) (pGxy(i), i=1,DimG)  ! we use symmetry

      READ(12,*) (pGy(i), i=1,DimG)
C      WRITE(*,*) (pGy(i), i=1,DimG)

      READ(12,*) (pGyz(i), i=1,DimG)
C      WRITE(*,*) (pGyz(i), i=1,DimG)

      READ(12,*) (pGxz(i), i=1,DimG) !  we use symmetry
C      WRITE(*,*) (pGxz(i), i=1,DimG) !  we use symmetry
      
      READ(12,*) (pGyz(i), i=1,DimG) !  we use symmetry
C      WRITE(*,*) (pGyz(i), i=1,DimG) !  we use symmetry

      READ(12,*) (pGz(i), i=1,DimG)
C      WRITE(*,*) (pGz(i), i=1,DimG)

C      END IF
     
      CLOSE(12)

      RETURN
400   CALL openerr(io,file(1:ii))
      END

      SUBROUTINE lirePermF(dir)
C     #####################
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementF.h'

      CHARACTER*128 file,dir
      REAL x
      INTEGER i,ii,io

#ifdef DBG
      WRITE(zz,*) '@DBG: lirePermF  (enter)'
#endif
      
      CALL het_file_name(dir,0,file)
      ii=index(file,' ')
      OPEN(12,file=file(1:ii),iostat=io,err=400,status='old')
      PRINT *,'>>> Reading file  ',file(1:ii)


C ===========  read Joe's format
      READ(12,'(I5)') i   ! ngros 1,2,3 In future read this and make a check.!!!!!!
      IF(i .NE. diml(1)) THEN
          WRITE(*,*) '>> WARNING1 (lirePerm) Incorect dimensions.'
      END IF
C      PRINT *, i
      READ(12,'(I5)') i
      IF(i .NE. diml(2)) THEN
          WRITE(*,*) '>> WARNING2 (lirePerm) Incorect dimensions.'
      END IF
C      PRINT *, i
      READ(12,'(I5)') i
      IF(i .NE. diml(3)) THEN
          WRITE(*,*) '>> WARNING3 (lirePerm) Incorect dimensions.'
      END IF
      READ(12,*) (permX(i), i=1,DimF)
C      WRITE(*,*) (permX(i), i=1,DimF) 

      READ(12,*) (x, i=1,DimF)

      READ(12,*) (x, i=1,DimF)

      READ(12,*) (x, i=1,DimF)  ! we use symmetry

      READ(12,*) (permY(i), i=1,DimF)
C      WRITE(*,*) (permY(i), i=1,DimF)

      READ(12,*) (x, i=1,DimF)

      READ(12,*) (x, i=1,DimF) !  we use symmetry
      
      READ(12,*) (x, i=1,DimF) !  we use symmetry

      READ(12,*) (permZ(i), i=1,DimF)
C      WRITE(*,*) (permZ(i), i=1,DimF)

C      END IF
     
      CLOSE(12)

      RETURN
400   CALL openerr(io,file(1:ii))
      END

      SUBROUTINE calInvPer()
C     #####################
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementG.h'

      REAL AM(3,3),iAM(3,3)

      INTEGER i

#ifdef DBG
      WRITE(zz,*) '@DBG: calInvPer  (enter)'
#endif
      
      IF(complet.EQ.1) THEN
      DO i=1,DimG
       AM(1,1)=pGx(i)
       AM(2,2)=pGy(i)
       AM(3,3)=pGz(i)
       AM(1,2)=pGxy(i)
       AM(1,3)=pGxz(i)
       AM(2,3)=pGyz(i)
       AM(2,1)=AM(1,2)
       AM(3,1)=AM(1,3)
       AM(3,2)=AM(2,3)
C       CALL LINRG(3,AM,3,iAM,3) ! LINRG(n,A,lda,Ainv,ldaAinv)
       ipGx(i)=iAM(1,1)
       ipGy(i)=iAM(2,2)
       ipGz(i)=iAM(3,3)
       ipGxy(i)=iAM(1,2)
       ipGxz(i)=iAM(1,3)
       ipGyz(i)=iAM(2,3)
      END DO
      END IF
 
      RETURN
      END

      SUBROUTINE FGSort(title,nom)
C     ############################

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'gloTableauxG.h'

      INTEGER i,j,j1,j2,ii,io
      CHARACTER*128 title,nom
      CHARACTER*9 datum

#ifdef DBG
      WRITE(zz,*) '@DBG:  FGSort    (enter)'
#endif
      ii=index(nom,' ')
      OPEN(12,file=nom(1:ii-1),err=400,iostat=io)
      PRINT *,'>>> Writing to  ',nom(1:ii-1)

      CALL DATE_Y2KBUG(datum)
      i=index(title,' ')
      WRITE(12,*) title(1:i),datum
      DO i=1,ndfg
        WRITE(12,77) i
        j1=entreG(i)
        j2=entreG(i+1)-1 
        DO j=j1,j2
          WRITE(12,76) SG(j),KRWTG1(j),KRWTG2(j),KRWTG3(j),
     >                        KROTG1(j),KROTG2(j),KROTG3(j),PCTG(j)
        END DO
      END DO
      CLOSE(12)
76    FORMAT(F7.5,1x,6(F8.6,1x),G12.6)
77    FORMAT(4x,'S',6x,'krw_x',4x,'krw_y',4x,'krw_z',4x,'kro_x',4x,
     >    'kro_y',4x,'kro_z',4x,'Pc / Tableau ',i3)
      RETURN
400   CALL openerr(io,nom)
      END


      SUBROUTINE lirePoroG(nom,phiG)
C     ################################

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      
      REAL phiG(NUMMG)
      INTEGER ii,i,io
      CHARACTER*128 nom

#ifdef DBG
      WRITE(zz,*) '@DBG:lirePoroG   (enter)'
#endif

      ii=index(nom,' ')-1
      OPEN(12,file=nom(1:ii),iostat=io,err=400,status='old')
      PRINT *,'>>> Reading file  ',nom(1:ii)

      READ(12,*) 
      DO i=1,DimG
        READ(12,*) phiG(i)
      END DO
      CLOSE(12)
      RETURN
400   CALL openerr(io,nom)
      END

      SUBROUTINE ecriPoroG(base_f,PhiG)
C     #####################################
C
C     Preparation de donnees pour simulation grossiere.
C     Generation de fichier:
C                            swof  

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'

      INTEGER ii,jj,io
      INTEGER i,j,k,l
      REAL phiG(NUMMG)
      CHARACTER*128 base_f,file,tmp_dir,tmp_file
      CHARACTER*3 nCh,nCh1,nCh2,nCh3,int2ch        
      CHARACTER*64 num

#ifdef DBG
      WRITE(zz,*) '@DBG: ecriPoroG  (enter)'
#endif

      CALL sep(inphi,tmp_dir,tmp_file)
      ii=index(tmp_file,' ')-1
C =============================================  think about the file name !!!!!
      nCh1=int2ch(ngros(1))
      nCh2=int2ch(ngros(2))
      nCh3=int2ch(ngros(3))

      jj=index(base_f,' ')-1
      j=index(nCh1,' ')-1
      k=index(nCh2,' ')-1
      l=index(nCh3,' ')-1
  
      num=nCh1(1:j)//'x'//nCh2(1:k)//'x'//nCh3(1:l)//'  '
      j=index(num,' ')-1

C23456789012345678901234567890123456789012345678901234567890123456789012
      file=base_f(1:jj)//'/'//base_f(1:jj)//'_'//num(1:j)//'/'//tmp_file
     >(1:ii)
      jj=index(file,' ')-1

      OPEN(12,file=file(1:jj),err=810,iostat=io)
      PRINT *,'>>> Writing to  '//file(1:jj)          
      WRITE(12,'(4HPORO)') ! ECLIPSE key word

      DO i=1,DimG
        WRITE(12,*) phiG(i)
      END DO

      RETURN

810   CALL openerr(io,file(1:jj))

      END






      SUBROUTINE lireTabl()
C     #####################
C     Lecture des tableaux de fonctions de la saturation 
C     dans le fichier du type SWOF (de l'ECLIPSE). Il faut 
C     egalement lire le fichier du type SATNUM. 
C     
C 
C     swof     = nom du fichier du type SWOF (eclipse)
C     satnm    = nom du fichier du type SATNM (eclipse)
C     diml   = dimensions de la domaine 
C                  diml(1)=nx, diml(2)=ny, diml(3)=nz
C     S,KRWT,KROT,PCT = tableaux de la saturation et des fonctions
C           de la saturation (permeabilite relative de l'eau, 
C           permeabilite relative de l'huile, pression capillare)
C           KRWT(i)=krw(S(i)) etc.
C     entre = le tableau de indices. 
C             entre(i) = est le premier element du i-eme
C                        tableau. Le i-eme tableau se trouve dans
C                        S(j),KRWT(j) pour j=entre(i),...,entre(i+1)-1,
C                        S(j),KROT(j) pour j=entre(i),...,entre(i+1)-1,
C                        S(j),PCT(j)  pour j=entre(i),...,entre(i+1)-1.
C     Indx = le tableau des pointures a entre.
C             Indx(i) : i est l'indice de maille fin; 
C             Indx(i)=le numero des tableaux qui appartiennent aux  
C                     fonctions correspondant a maille i.
C     ndf  = numero de tableaux

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'gloTableauxF.h'

      INTEGER io,ii,i,j,k,kk,noTabl
      INTEGER skip
      CHARACTER*80 ligne

#ifdef DBG
      WRITE(zz,*) '@DBG: lireTable  (enter)'
#endif


C >>>  Lecture de SWOF 

      ii=index(swof,' ')-1
      OPEN(12,file=swof(1:ii),err=500,iostat=io,status='old')
      PRINT *,'>>> Reading file  ',swof(1:ii)

      k=0  ! numero de ligne
      DO WHILE(.TRUE.)
        k=k+1
        READ(12,'(A80)',err=300,end=300) ligne
        i=skip(ligne,' ',80)             ! supprime les blancs
        IF(i.EQ.-1)            GO TO 55  ! ligne est vide
        IF(ligne(1:2).EQ.'--') GO TO 55  ! ligne de commentaire
        IF(ligne(1:4).NE.'SWOF') THEN     
           PRINT *,'@ERROR:lireTabl: missing  SWOF keyword.'
           CALL exit(-1)
        ELSE
          GO TO 66
        END IF
55      CONTINUE
      END DO                          ! maintenant le SWOF est lu.

66    noTabl=1  ! numero de tableau
      entre(1)=1
      kk=0      ! numero de donnee lue
      DO WHILE(.TRUE.)
        k=k+1
        READ(12,'(A80)',err=300,end=700) ligne
        i=skip(ligne,' ',80)                   ! supprime les blancs
        IF(i.EQ.-1) GO TO 44                   ! ligne est vide
        IF(ligne(1:2).EQ.'--') GO TO 44        ! ligne de commentaire
        IF(LGE(ligne(1:1),'A')) GO TO 700
C        ligne(1:1)>='A' ca veut dire qu'il s'agit d'un non numero.
C        C'est probablement nouveau mot de cle et donc notre tableaux
C        sont complets.
        j=index(ligne,'/')
        IF(j.EQ.0) THEN                  ! la ligne ne contient pas '/'
           kk=kk+1
           READ(ligne,*,err=300) S(kk),KRWT(kk),KROT(kk),PCT(kk)
        ELSE
           IF(j.EQ.1) THEN      ! '/' dans la premiere colonne.
            noTabl=noTabl+1     ! il n'y a rien autre dans cette ligne
            entre(noTabl)=kk+1
           ELSE
            kk=kk+1
            READ(ligne,*,err=300) S(kk),KRWT(kk),KROT(kk),PCT(kk)
            noTabl=noTabl+1 
            entre(noTabl)=kk+1
           END IF
        END IF
44      CONTINUE
      END DO
      CLOSE(12)

700   CONTINUE
#ifdef DBG
      WRITE(zz,*) '@DBG lireTabl: Read ',noTabl-1,
     >' tables of functions with following no of points'
      WRITE(zz,*) '@DBG No of table    No of points'
C              12345678901234567890123456789012
      DO i=1,noTabl-1
      WRITE(zz,71) i,entre(i+1)-entre(i)
 71   FORMAT(' @DBG',4x,i5,14x,i5)
      END DO
#endif

      ndf=noTabl-1

      ii=index(satnm,' ')-1
      OPEN(12,file=satnm(1:ii),err=400,iostat=io,status='old')
      PRINT *,'>>> Reading ',satnm(1:ii)

      k=0
      DO WHILE(.TRUE.)
        k=k+1
        READ(12,'(A80)',err=301,end=301) ligne
        i=skip(ligne,' ',80)                  ! supprime les blancs
        IF(i.EQ.-1)            GO TO 155      ! ligne est vide
        IF(ligne(1:2).EQ.'--') GO TO 155      ! ligne de commentaire
        IF(ligne(1:6).NE.'SATNUM') THEN     
           PRINT *,'@ERROR:lireTabl: missing SATNUM keyword.'
           CALL exit(-1)
        ELSE
          GO TO 166
        END IF
155     CONTINUE
      END DO                          ! maintenant le SATNM est lu.

166   kk=0  ! le numero de donnees lues
      DO WHILE(.TRUE.)
        READ(12,'(A80)',err=301,end=501) ligne
        i=skip(ligne,' ',80)                   ! supprime les blancs
        IF(i.EQ.-1)             GO TO 144      ! ligne est vide
        IF(ligne(1:2).EQ.'--')  GO TO 144      ! ligne de commentaire
        IF(LGE(ligne(1:1),'A')) GO TO 501
C        ligne(1:1)>='A' ca veut dire qu'il s'agit d'un non numero.
C        C'est probablement nouveau mot de cle et donc notre tableau
C        est complet.
        j=index(ligne,'/')
        IF(j.EQ.0) THEN                  ! la ligne ne contient pas '/'
         kk=kk+1
         READ(ligne,*,err=301) Indx(kk)
        ELSE
         IF(j.EQ.1) THEN      ! '/' dans la premiere colonne.
          GO TO 501           ! il n'y a rien autre dans cette ligne
         ELSE
          kk=kk+1
          READ(ligne,*,err=301) Indx(kk)
          GO TO 501  
         END IF
        END IF
144     CONTINUE
      END DO
      
501   CONTINUE
#ifdef DBG
      WRITE(zz,*) '@DBG lireTabl: Reading of ',satnm(1:ii),' done.'
      WRITE(zz,*) '@DBG lireTabl: ',kk,' blocks read. (DimF= ',DimF,')'
#endif
      CLOSE(12)

      RETURN
400   CALL openerr(io,satnm)
500   CALL openerr(io,swof)
300   ii=index(swof,' ')
      PRINT *,'@ERROR:lireTabl: when reading file    ',swof(1:ii)
      PRINT *,'@ERROR:donnee numero ',k
      CALL exit(-1)
301   ii=index(satnm,' ')
      PRINT *,'@ERROR:lireTabl: when reading file    ',satnm(1:ii)
      PRINT *,'@ERROR:donnee numero ',k
      CALL exit(-1)
200   ii=index(swof,' ')
      PRINT *,'@ERROR:lireTabl: when reading file    ',swof(1:ii)
      PRINT *,'@ERROR:ligne ',i+2
      CALL exit(-1)
600   ii=index(satnm,' ')
      PRINT *,'@ERROR:lireTabl: end of file    ',satnm(1:ii)
      PRINT *,'@ERROR:I read ',i,' lines but expecting ',DimF
      CALL exit(-1)
      END

      SUBROUTINE lirePA(PerPhi,fichier)
C     ##################################
C     Lire permeabilites absolues, porosite etc.
C     PerPhi  = le champ dont il faut lire les permeabilites ou les
C               porosites.
C     fichie = nom de fichier avec les donnees.
C                Le fichier doit etre ouvert.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'flags.h'

      CHARACTER*(128) fichier
      REAL PerPhi(NUMMF),Tmp(NUMMF)
      LOGICAL check
      INTEGER ik,i,j,k,e,nx,ny,nz,base,io,ordF

#ifdef DBG 
      WRITE(zz,*) '@DBG: LirePA     (enter)'
#endif
      ik=index(fichier,' ')-1
      OPEN(12,file=fichier(1:ik),err=100,iostat=io,status='old')
      PRINT *,'>>> Reading    ',fichier(1:ik)

      READ(12,*,err=300)
      READ(12,*,err=300,end=300) (Tmp(i),i=1,DimF)
      CLOSE(12)

      e=0
      DO 13 k=1,dims(3)
      DO 13 j=1,dims(2)
      DO 13 i=1,dims(1)
             e=e+1
             PerPhi(e)=Tmp(ordF(i,j,k))
13    CONTINUE

      DO i=1,DimF
       IF(PerPhi(i).LE. 0.0) THEN
       PRINT *,'@DBG:ERROR: LirePA Read value less or equal to zero!'
       END IF
      END DO
      RETURN
300   PRINT *,'@ERROR: lirePA: while reading file   ',fichier(1:ik)
      PRINT *,'@ERROR: lirePA: e= ',e
      CALL exit(-1) 
100   CALL openerr(io,fichier)
      END
C23456789012345678901234567890123456789012345678901234567890123456789012
C       10        20        30        40        50        60        70
      SUBROUTINE ecriSatnumG(IndxG,base)
C     ############################################
C
C     Ecriture de fichier satnum pour la simulation fin         
C     homogene.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
C      INCLUDE 'gloTableauxF.h'
C      INCLUDE 'gloTableauxG.h'

      INTEGER Fl(NUMMF),ii,jj,io,ipp,dimFon,j,k,l
      INTEGER IndxG(NUMMG)
      CHARACTER*128 base,file,tmp_dir,tmp_f
      CHARACTER*3 nCh,nCh1,nCh2,nCh3,int2ch        
      CHARACTER*64 num

#ifdef DBG
      WRITE(zz,*) '@DBG: ecriSatnumG(entre)'
#endif

      CALL sep(satnm,tmp_dir,tmp_f)
      ii=index(tmp_f,' ')-1
C ================================   Here we need to change the name of the file
      nCh1=int2ch(ngros(1))
      nCh2=int2ch(ngros(2))
      nCh3=int2ch(ngros(3))

      jj=index(base,' ')-1
      j=index(nCh1,' ')-1
      k=index(nCh2,' ')-1
      l=index(nCh3,' ')-1
  
      num=nCh1(1:j)//'x'//nCh2(1:k)//'x'//nCh3(1:l)//'  '
      j=index(num,' ')-1

      file=base(1:jj)//'/'//base(1:jj)//'_'//num(1:j)//'/'//tmp_f(1:ii)
      jj=index(file,' ')-1
      OPEN(12,file=file(1:jj),err=900,iostat=io)
      PRINT *,'>>> Ecriture de '//file(1:jj)        

C  WARNING nontrivial version is needed when we save original
C          values around wells!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

      WRITE(12,'(6HSATNUM)') ! ECLIPSE key word
      DO ipp=1,DimG
         WRITE(12,*) IndxG(ipp)
      END DO

      CLOSE(12)
      RETURN

900   CALL openerr(io,file(1:jj))

      END

      SUBROUTINE ecriSwofG(dimFon,flag,base_f)
C     #####################################
C
C     Preparation de donnees pour simulation grossiere.
C     Generation de fichier:
C                            swof  

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementF.h'
      INCLUDE 'gloGisementG.h'
      INCLUDE 'gloTableauxF.h'
      INCLUDE 'gloTableauxG.h'

      INTEGER ii,jj,io,ipp,numpt,base,dimFon,flag
      INTEGER j,k,l
      CHARACTER*128 base_f,file,tmp_dir,tmp_file
      CHARACTER*3 nCh,nCh1,nCh2,nCh3,int2ch        
      CHARACTER*64 num

#ifdef DBG
      WRITE(zz,*) '@DBG: ecriSwofG  (enter)'
#endif

889   FORMAT(F6.4,2X,F6.4,2X,F6.4,2X,E11.4)
888   FORMAT(12H-- Table no ,I3,', homogenized, direction ',A1) 
C               123456789*1234

      CALL sep(swof,tmp_dir,tmp_file)
      ii=index(tmp_file,' ')-1
C =============================================  think about the file name !!!!!
      nCh1=int2ch(ngros(1))
      nCh2=int2ch(ngros(2))
      nCh3=int2ch(ngros(3))

      jj=index(base_f,' ')-1
      j=index(nCh1,' ')-1
      k=index(nCh2,' ')-1
      l=index(nCh3,' ')-1
  
      num=nCh1(1:j)//'x'//nCh2(1:k)//'x'//nCh3(1:l)//'  '
      j=index(num,' ')-1

C23456789012345678901234567890123456789012345678901234567890123456789012
      file=base_f(1:jj)//'/'//base_f(1:jj)//'_'//num(1:j)//'/'//'xyz'//
     >tmp_file(1:ii)
      jj=index(file,' ')-1

      OPEN(12,file=file(1:jj),err=810,iostat=io)
      PRINT *,'>>> Ecriture de '//file(1:jj)          
      WRITE(12,'(7HXYZSWOF)') ! ECLIPSE key word
      WRITE(12,'(30H-- sat    krw    kro        Pc)')  
C                    123456  123456  123456  123456789**

      IF(flag.EQ.0) THEN  ! flag =0 ==> ecrit Pc 

      DO ipp=1,dimFon
        WRITE(12,888) ipp,'X'
        base=entreG(ipp) 
        numpt=entreG(ipp+1)-base
        DO jj=0,numpt-1
          WRITE(12,889) 
     >        SG(base+jj),KRWTG1(base+jj),KROTG1(base+jj),PCTG(base+jj)
        END DO
        WRITE(12,*) '/'
        WRITE(12,888) ipp,'Y'
        DO jj=0,numpt-1
          WRITE(12,889) 
     >        SG(base+jj),KRWTG2(base+jj),KROTG2(base+jj),PCTG(base+jj)
        END DO
        WRITE(12,*) '/'
        WRITE(12,888) ipp,'Z'
        DO jj=0,numpt-1
          WRITE(12,889) 
     >        SG(base+jj),KRWTG3(base+jj),KROTG3(base+jj),PCTG(base+jj)
        END DO
        WRITE(12,*) '/'
      END DO

      ELSE   ! flag <> 0 ==> met le Pc a zero 

      DO ipp=1,dimFon
        WRITE(12,888) ipp,'X'
        base=entreG(ipp) 
        numpt=entreG(ipp+1)-base
        DO jj=0,numpt-1
          WRITE(12,889) 
     >        SG(base+jj),KRWTG1(base+jj),KROTG1(base+jj),0.0
        END DO
        WRITE(12,*) '/'
        WRITE(12,888) ipp,'Y'
        DO jj=0,numpt-1
          WRITE(12,889) 
     >        SG(base+jj),KRWTG2(base+jj),KROTG2(base+jj),0.0
        END DO
        WRITE(12,*) '/'
        WRITE(12,888) ipp,'Z'
        DO jj=0,numpt-1
          WRITE(12,889) 
     >        SG(base+jj),KRWTG3(base+jj),KROTG3(base+jj),0.0
        END DO
        WRITE(12,*) '/'
      END DO

      ENDIF
      CLOSE(12)

      RETURN

810   CALL openerr(io,file(1:jj))

      END

      SUBROUTINE satDistr(SG,PCTG,entreG,IndxG,phiH)
C     ###############################################
C      On suppose ici que les valeurs minimal et maximale de la 
C      pression capillaires sont egales.
C      npp = numero de points dans interpolation de la courbe de la
C            pression capillaire homogeneisee. 
C      locS = les valeurs de la saturation obtenues a partire de
C             courbes de la pression capillaire, pour la valeur 
C             de pression donnee.
C             locS(i,j) i= le numero de la maille grossiere
C                       j= le numero de la fonction (sur le maillage
C                          fin).
C      disS = la distribution de la saturation dans tout la domaine,
C             pour pression capillaire donnee. La pression 
C             capillaire moyenne sur chaque maille grossiere peut
C             etre differente. 

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloTableauxF.h'

      REAL locS(NUMMG,NUMTABF),disS(NUMMF)
      REAL SG(DIMTABG),PCTG(DIMTABG),sc(NUMMG,DIMFONC)
      REAL theta(NUMMF)
      REAL phiH(NUMMG),u1(NUMMG),u2(NUMMG)
      REAL u,v,umax,umin,SHom
      REAL kro,krw,saturation,ds,eps,shtmp

      EXTERNAL kro,krw

      INTEGER npp1
      INTEGER entreG(NUMTABG+1),IndxG(NUMMG),ordG,FtoG
      INTEGER nof,i,i1,i2,j,l,count,k,p,q,r,n,m

#ifdef DBG
      WRITE(zz,*) '@DBG: satDistr   (enter)'
#endif
      nof=ndf  ! nof=numero de fonctions dans les tableaux

      CALL setTheta(theta) 

      eps=0.2/(npp-1)

      umin=PCT(entre(2)-1)
      umax=PCT(entre(1))

C >>> Verification si les pressions capillaires minimale et 
C     maximale sont bien egales.

      DO i=2,nof
       i1=entre(i) 
       i2=entre(i+1)-1 
       u=PCT(i1)
       v=PCT(i2)
       IF(abs(u-umax).GT.1.0E-7) THEN
        PRINT *,'>>satDistr: Values of  Pc_max are different.'
        PRINT *,' NoTableau= ',i,' pcmax= ',u,' pcmax(1)= ',umax
        CALL exit(-1)
       END IF
       IF(abs(v-umin).GT.1.0E-7) THEN
        PRINT *,'>>satDistr: Values of Pc_min are different.'
        PRINT *,' NoTableau= ',i,' pcmin= ',v,' pcmin(1)= ',umin
        CALL exit(-1)
       END IF
      END DO

#ifdef DBG
      WRITE(zz,*) '@DBG: satDistr: Pcmax= ',umax,' Pcmin= ',umin
#endif

C >>> Construction des tableaux de fonctions sur le maillage grossier.
C     (Pression capillaire)


      npp1=npp-1
      DO i=1,DimG             
        entreG(i)=(i-1)*npp+1 
      END DO                 
      entreG(DimG+1)=entreG(DimG)+npp 
                                     
      DO i=1,DimG
        IndxG(i)=i 
      END DO


C >>>  Calcule de la saturation moyenne pour la pression maximale.
C      On calcule ici la saturation ireductible ce qui est la moyenne
C      ponderee des saturations ireductibles.
C      Pour cette valeur de la pression capillaire on ne sort pas
c      K krw(x,S) parce que cette matrice est singuliere.


C >>> Le premier element de tableau <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      u=umax  
      DO i=1,ndf                           ! Ici nous calculons
         l=entre(i)                        ! la saturation pour 
         k=entre(i+1)-l                    ! press capil donnee.
         locS(1,i)=saturation(u,S(l),PCT(l),k)   
      END DO                                   

      DO i=2,DimG
        DO j=1,ndf
         locS(i,j)=locS(1,j)
        END DO
      END DO

C >>> Calcule de la saturation moyenne.
C >>> Ecriture des valeurs de fonctions aux tableaux.

      DO 850 k=1,ngros(3)
      DO 850 j=1,ngros(2)
      DO 850 i=1,ngros(1)
       l=ordG(i,j,k)
       r=entreG(IndxG(l))
       IF(phiH(l).NE.0.0) THEN
         SG(r)=SHom(locS,theta,i,j,k)/phiH(l)
       ELSE
         SG(r)=0.0
       END IF
       PCTG(r)=u
850   CONTINUE

#ifdef DBG
      WRITE(zz,*) '@DBG: satDistr: S_m moyenne = ',
     >                           (SG(entreG(IndxG(k))),k=1,DimG) 
#endif

      DO i=1,DimF
       disS(i)=locS(FtoG(i),Indx(i))
      END DO

C >>> Ecrit K kro(S) et le fichier de commande pour HOMOG.

      count=1
      CALL ecrKkr(baseo,count,entre,Indx,S,KROT,kro,disS)
      
C >>>  Derniere entree dans les tableaux.<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      u=umin
      DO i=1,ndf    
        l=entre(i)   
        k=entre(i+1)-l
        locS(1,i)=saturation(u,S(l),PCT(l),k) 
      END DO                               
      DO i=2,DimG
        DO j=1,ndf
         locS(i,j)=locS(1,j)
        END DO
      END DO

C >>> Calcule la saturation moyenne.
C >>> Ecrit les valeurs de pression capillaire dans le tableau.

      DO 851 k=1,ngros(3)
      DO 851 j=1,ngros(2)
      DO 851 i=1,ngros(1)
       l=ordG(i,j,k)
       r=entreG(IndxG(l))
       IF(phiH(l).NE.0.0) THEN
         SG(r+npp1)=SHom(locS,theta,i,j,k)/phiH(l)
       ELSE
         SG(r+npp1)=1.0
       END IF
       PCTG(r+npp1)=u
851   CONTINUE

#ifdef DBG
      WRITE(zz,*) '@DBG: satDistr: S_M mean    = ',
     >                           (SG(entreG(IndxG(k))+npp1),k=1,DimG) 
#endif
      
      DO i=1,DimF
       disS(i)=locS(FtoG(i),Indx(i))
      END DO

C >>> Ecrit  K krw(S) et le fichier de commande pour HOMOG.

      count=npp1
      CALL ecrKkr(basew,count,entre,Indx,S,KRWT,krw,disS)

C >>> Les points a l'interieur du tableau.<<<<<<<<<<<<<<<<<<<<<<<<<<<<

      DO i=1,DimG
        j=entreG(IndxG(i))
        k=entreG(IndxG(i)+1)
        sc(i,1)  =SG(j)         ! S^*_min dans la maille grossiere i
        sc(i,npp)=SG(k-1)       ! S^*_max dans la maille grossiere i
        u1(i)=umax 
        u2(i)=umin   
        ds=(sc(i,npp)-sc(i,1))/npp
        DO j=2,npp1
          sc(i,j)=sc(i,1)+ds*j
        END DO
      END DO

C >>> Dans i-eme maille grossiere on cherche les valeurs de la 
C     pression capillaire dans les saturations S(j) qui sont pas 
C     plus que eps eloignes de sc(i,j).
      
      DO 177 n=2,npp1

      DO k=1,DimG 
        u2(k)=umin
      END DO

      DO 852 k=1,ngros(3)
      DO 852 j=1,ngros(2)
      DO 852 i=1,ngros(1)
        l=ordG(i,j,k)
341     u=(u1(l)+u2(l))/2.0
        DO m=1,ndf    
         p=entre(m)   
         q=entre(m+1)-p
         locS(l,m)=saturation(u,S(p),PCT(p),q) 
        END DO                               
        IF(phiH(l).NE.0.0) THEN
          shtmp=SHom(locS,theta,i,j,k)/phiH(l)
        ELSE
          shtmp=sc(l,n)
        END IF
        IF(shtmp.LE.sc(l,n)-eps) THEN
         u1(l)=u
         GO TO 341
        END IF
        IF(shtmp.GE.sc(l,n)+eps) THEN
         u2(l)=u
         GO TO 341
        END IF
#ifdef DBG
C       WRITE(zz,*) '@DBG: satDistr: n= ',n,'  u= ',u,' s= ',shtmp,' sc=
C    > ',sc(l,n)
#endif
        r=entreG(IndxG(l))
        SG(r+n-1)=shtmp
        PCTG(r+n-1)=u
852     CONTINUE
        u1(l)=u
        u2(l)=umin
        DO r=1,DimF
          disS(r)=locS(FtoG(r),Indx(r))
        END DO

C >>> This output is a bit confusing. 
C      print *,' >>> % ',n,' pc= ',u,(locS(1,r),r=1,ndf)

C >>> Ecrit K kro(S), K krw(S) et le fichier de commande pour HOMOG.
      count=n
      CALL ecrKkr(baseo,count,entre,Indx,S,KROT,kro,disS)
      count=n-1
      CALL ecrKkr(basew,count,entre,Indx,S,KRWT,krw,disS)

177   CONTINUE

      RETURN  
      END

      SUBROUTINE ecrKkr(base,count,entre,Indx,S,KRT,kr,disS)
C     ######################################################
C     Calcule K kr(S) et ecrit ca dans le fichier. On meme temps
C     genere le fichier du commande pour HOMOG (not any more).

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'flags.h'
      INCLUDE 'gloGisementF.h'

      REAL disS(NUMMF)
      REAL S(DIMTABF),KRT(DIMTABF)
      REAL kr,uu,vv,ww,eps

      EXTERNAL kr

      INTEGER entre(NUMTABF+1),Indx(NUMMF)
      INTEGER i,j,count,ii,l,nl

      CHARACTER*32 intFich
      CHARACTER*3 countCh
      CHARACTER*128 base, file

      PARAMETER (eps=1.0E-7)

#ifdef DBG
      WRITE(zz,*) '@DBG: ecrKkr     (enter)'
#endif
C >>> Compose le nom du fichier de K kr(S) et ouvert le.

      CALL het_file_name(base,count,file)
      ii=index(file,' ')-1

      OPEN(12,file=file(1:ii))
      PRINT *,'>>> WRITING to file '//file(1:ii)

C >>> Ecrit les donnees dans tris colonnes pour HOMOG

      WRITE(12,*) diml(1)
      WRITE(12,*) diml(2)
      WRITE(12,*) diml(3)
      DO i=1,DimF
        j=Indx(i)                           ! j is func. table number applied to block i
        l=entre(j)                          ! l is the first row in the funct. table
        nl=entre(j+1)-l                     ! nl is number of rows in the table
        vv=kr(disS(i),S(l),KRT(l),nl)
C           if((abs(vv-1.0).gt.1.0E-4).and.(count.eq.1)) print *,vv
        uu=permX(i)*vv              
        WRITE(12,'((G13.6,2X))') uu
#ifdef DBG
C       IF(abs(uu).LT.eps) THEN
C         WRITE(zz,*) '@DBG: WARNING: Fichier ',file(1:ii),' ligne ',i,
C    >       ' entree proche a zero!'
C         WRITE(zz,*) '@DBG: WARNING: PemAbs= ',permX(i),' PermX*kr=
C    > ',                                                           uu
C       END IF
#endif
      END DO

      DO i=1,DimF
        WRITE(12,'((F3.1,2X))') 0.0        ! kr * K_xy
      END DO

      DO i=1,DimF
        WRITE(12,'((F3.1,2X))') 0.0        ! kr * K_xz
      END DO

      DO i=1,DimF
        WRITE(12,'((F3.1,2X))') 0.0        ! kr * K_yx
      END DO

      DO i=1,DimF
        j=Indx(i)                           ! j is func. table number applied to block i
        l=entre(j)                          ! l is the first row in the funct. table
        nl=entre(j+1)-l                     ! nl is number of rows in the table
        vv=kr(disS(i),S(l),KRT(l),nl)
        uu=permY(i)*vv                 
        WRITE(12,'(G13.6,2X)') uu
#ifdef DBG
C       IF(abs(uu).LT.eps) THEN
C         WRITE(zz,*) '@DBG: WARNING: Fichier ',file(1:ii),
C    >' ligne ',i,' entree proche a zero!'
C         WRITE(zz,*) '@DBG: WARNING: PemY= ',permY(i),' PermY*kr=',uu
C       END IF
#endif
      END DO

      DO i=1,DimF
        WRITE(12,'((F3.1,2X))') 0.0        ! kr * K_yz
      END DO

      DO i=1,DimF
        WRITE(12,'((F3.1,2X))') 0.0        ! kr * K_zx
      END DO

      DO i=1,DimF
        WRITE(12,'((F3.1,2X))') 0.0        ! kr * K_zy
      END DO

      DO i=1,DimF
        j=Indx(i)                           ! j is func. table number applied to block i
        l=entre(j)                          ! l is the first row in the funct. table
        nl=entre(j+1)-l                     ! nl is number of rows in the table
        vv=kr(disS(i),S(l),KRT(l),nl)
        uu=permZ(i)*vv              
        WRITE(12,'(G13.6,2X)') uu 
#ifdef DBG
C       IF(abs(uu).LT.eps) THEN
C         WRITE(zz,*) '@DBG: WARNING: Fichier ',file(1:ii),
C    >' ligne ',i,' entree proche a zero!'
C         WRITE(zz,*) '@DBG: WARNING: PermZ= ',permZ(i),' PermZ*kr=',uu
C       END IF
#endif
      END DO

      CLOSE(12)
        
C >>> Ecrit le fichier de commande pour HOMOG.
C ......... we dont need this any more. HOMOG is a hystory
C      CALL ecriHOMOG(base(1:ii-1)//countCh//' ')
      RETURN
      END

      SUBROUTINE phiHom(phiH,phiF)
C     #################################
C
C     La procedure calcule phiH(): une valeur pour chaque maille
C     grossiere, definit par
C                 __ 
C                 >   theta(i) phi(i)
C                 -- i
C        phiH(j)= -------------------
C                    sum theta(i)
C                       i
C     ou j est l'indice de la maille grossiere, et i est l'indice de la
C     maille fin: i parcourt toutes les mailles fines qui se trouvent
C     dans la maille grossiere j.
C

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
C      INCLUDE 'fichiers.h'
C      INCLUDE 'gloGisementF.h'

      REAL phiH(NUMMG),phiF(NUMMF),phimin
      REAL theta(NUMMF)          ! not in common any more 
      CHARACTER*128 x

      INTEGER i,j,k,agx(0:MAXGX),agy(0:MAXGY),agz(0:MAXGZ)
      INTEGER if,jf,kf,ii,jj,kk,l,ll,basex,basey,basez,ordG
      INTEGER cnta,cntm,cntt
      INTEGER flag ! flag =1 utilise le seuil, flag =0 n'utilise pas!
      REAL volume

#ifdef DBG
      WRITE(zz,*) '@DBG: phiHom     (enter)'
#endif

      CALL setTheta(theta)

      phimin=1000000.0                        ! trouve la 
      DO i=1,DimF                             ! porosite
       IF(phiF(i).NE.0.0) THEN                 ! minimale
          IF(phiF(i).LT.phimin) phimin=phiF(i)  ! phimin
       END IF
      END DO
      WRITE(zz,*) '@DBG: phiHom: ph_min = ',phimin

      agx(0)=0
      agy(0)=0
      agz(0)=0
      DO i=1,MAXGX
       agx(i)=agregx(i)
      END DO
      DO i=1,MAXGY
       agy(i)=agregy(i)
      END DO
      DO i=1,MAXGZ
       agz(i)=agregz(i)
      END DO

      basez=0
      DO 200 k=1,ngros(3)        ! boucle sur mailles grossieres
       basez=basez+agz(k-1)      ! (i,j,k) est l'indice de la maille
       basey=0                   ! grossiere.
       DO 200 j=1,ngros(2)       ! (basex,basey,basez) est l'indice
        basey=basey+agy(j-1)     ! dans le maillage fin de premier 
        basex=0                  ! point de la maille grossiere
        DO 200 i=1,ngros(1)      ! (i,j,k). 
         basex=basex+agx(i-1)
         l=(k-1)*ngros(2)*ngros(1)+(j-1)*ngros(1)+i 
C  ..... l correspond a (i,j,k) dans le maillage grossier.
         phiH(l)=0.0
         volume=0.0

         DO 100 kf=1,agz(k)      ! boucle sur les maille fines qui se 
         DO 100 jf=1,agy(j)      ! trouvent dans la maille grosiere
         DO 100 if=1,agx(i)      ! (i,j,k).
           ii=basex+if    
           jj=basey+jf
           kk=basez+kf
           ll=(kk-1)*dims(2)*dims(1)+(jj-1)*dims(1)+ii
C  .....   ll correspond a (ii,jj,kk) dans le maillage fin.
           phiH(l)=phiH(l)+theta(ll)*phiF(ll)
           volume=volume+theta(ll)
100      CONTINUE
         phiH(l)=phiH(l)/volume
200   CONTINUE

      RETURN
      END

      REAL FUNCTION SHom(locS,theta,i,j,k)
C     ###################################
C     dims() = dimensions du maillage fin       
C     ngros() = dimensions du maillage grossier
C     agregx(),agregy(),agregz() = taux d'agregation
C     theta() = volumes
C     phi() = porosite 
C     S(i) est donnee par locS(j) ou j=Indx(i).
C     La procedure calcule phiH(): une valeur pour chaque maille
C     grossiere, definit par
C                 __ 
C                 >   theta(i) phi(i) S(i)
C                 -- i
C       SHom(j)= -----------------------
C                    sum theta(i)
C                       i
C     ou j est l'indice de la maille grossiere, et i est l'indice de la
C     maille fin: i parcourt toutes les mailles fines qui se trouvent
C     dans la maille grossiere j.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'gloGisementF.h'
      INCLUDE 'gloTableauxF.h'

      REAL locS(NUMMG,NUMTABF),theta(NUMMF)

      INTEGER i,j,k
      INTEGER if,jf,kf,ii,jj,kk,l,ll,basex,basey,basez
      REAL volume

#ifdef DBG
      WRITE(zz,*) '@DBG: SHom       (enter)'
#endif

      baseX=0
      DO l=1,i-1 
         baseX=baseX+agregx(l)
      END DO
      baseY=0
      DO l=1,j-1 
         baseY=baseY+agregy(l)
      END DO
      baseZ=0
      DO l=1,k-1 
         baseZ=baseZ+agregz(l)
      END DO

      l=(k-1)*ngros(2)*ngros(1)+(j-1)*ngros(1)+i 
C  ..... l correspond a (i,j,k) dans le maillage grossier.

      SHom=0.0
      volume=0.0

      DO 100 kf=1,agregz(k)      ! boucle sur les maille fines qui se 
      DO 100 jf=1,agregy(j)      ! trouvent dans la maille grosiere
      DO 100 if=1,agregx(i)      ! (i,j,k).
         ii=basex+if    
         jj=basey+jf
         kk=basez+kf
         ll=(kk-1)*dims(2)*dims(1)+(jj-1)*dims(1)+ii
C  .....   ll correspond a (ii,jj,kk) dans le maillage fin.
         SHom=SHom+theta(ll)*phi(ll)*locS(l,Indx(ll))
         volume=volume+theta(ll)
100      CONTINUE
         SHom=SHom/volume
      RETURN
      END

      REAL FUNCTION saturation(u,S,Pc,n)
C     ######################################
C
C     Pour une valeur de la presion capillaire donnee ( = u )
C     la fonction calcul la saturation s=Pc^-1(u). Pc est donnee
C     comme un tableau: S est tableau de saturation est Pc
C     est le tableau de pression corresponant. Les valeurs
C     se trouvent dans (S(1),Pc(1)),...(S(n),Pc(n)).
C  
C     u = la pression capillaire donnee (input)
C     S(j),Pc(j) pour j=1,...,n doit etre le tableau de
C     pression capillaire. Pc(j)=Pc(S(j)).
C     u,S,Pc,n  (input)
C    
      IMPLICIT NONE
      INCLUDE 'params.h'

      REAL S(DIMFONC),Pc(DIMFONC)
      REAL u,pc0,pc1,s0,s1
      INTEGER i,n

#ifdef DBG
      IF(n.LT.1) THEN
       PRINT *,'@ERROR:functions of saturation: n=',n
       CALL exit(-1)          
      END IF
#endif

      pc1=Pc(1)
      s1=S(1)
C             s1 est la pression irreductible de l'eau. 

      IF(u.GE.pc1) THEN
        saturation=s1  ! Ici on continue la courbe de la  
        RETURN         ! pression capillaire verticalement dans 
      END IF           ! le point de la saturation irreductible.

      DO i=1,n-1
       pc0=pc1         ! pc0=Pc(i)
       pc1=Pc(i+1)     ! pc1=Pc(i+1)
       s0=s1           ! s0 =S(i)
       s1=S(i+1)       ! s1 =S(i+1)

#ifdef DBG
       IF(pc0.LE.pc1) THEN
         PRINT *,'@ERROR: Pc() function is not monotone.'
         CALL exit(-1)          
       END IF
#endif

       IF(u.GE.pc1) THEN                     
         saturation=s1-(pc1-u)*(s1-s0)/(pc1-pc0)
         RETURN
C                            Ici on a Pc(i) < u <= Pc(i+1).
       END IF
      END DO
C       Pression capillaire u est moins que la pression 
C       capillaire dans le point de la saturation ireductible
C       de l'huile. On fait ici interpolation on supposant que
C       Pc(1)=0.      
      IF(pc1.EQ.0.0) THEN
        saturation=s1
        RETURN           !   Peu probable.
      END IF
      saturation=1.0-(u/pc1)*(1.0-s1)
      RETURN
      END

      REAL FUNCTION kro(s,ST,KROT,n)
C     ##############################
C     s= saturation
C     ST KROT = les tableaux de saturation et kro
C     n = dimension des tableaux
C  >>> Calculate function value by simple linear interpolation

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'

      REAL s,ST(*),KROT(*)
      INTEGER n,i

      IF(s.LT.ST(1)) THEN
        PRINT *,'>>kro: la satur moins que la satur ireductibles.'
        PRINT *,'s= ',s,' s ired = ',ST(1)
        CALL exit(-1)
      END IF

      DO i=1,n-1
        IF(s.LT.ST(i+1)) THEN
          kro=KROT(i+1)+(s-ST(i+1))*(KROT(i)-KROT(i+1))/(ST(i)-ST(i+1))
#ifdef DBG
          IF(kro.GT.1.0) THEN
           WRITE(zz,*) '@DBG: kro ERROR: kro=',kro,'> 1.0! s=',s
           CALL exit(-1)
          END IF
#endif
          RETURN
        END IF
      END DO
      kro=0.0
      RETURN
      END

      REAL FUNCTION krw(s,ST,KRWT,n)
C     ##############################
C     s= saturation
C     ST KRWT = les tableaux de la saturation et krw
C     n = dimension des tableaux
C  >>> Calculate function value by simple linear interpolation

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'

      REAL s,ST(*),KRWT(*)
      INTEGER n,i

      IF(s.GT.ST(n)) THEN
        PRINT *,'>>krw: s > S_M.'
        PRINT *,'s= ',s,' S_M  = ',ST(n)
        CALL exit(-1)
      END IF

      DO i=n-1,1,-1
        IF(s.GT.ST(i)) THEN
          krw=KRWT(i+1)+(s-ST(i+1))*(KRWT(i)-KRWT(i+1))/(ST(i)-ST(i+1))
#ifdef DBG
          IF(krw.GT.1.0) THEN
           WRITE(zz,*) '@DBG: kro ERROR: krw=',krw,'> 1.0! s=',s
           CALL exit(-1)
          END IF
#endif
          RETURN
        END IF
      END DO
      krw=0.0
      RETURN
      END
C23456789012345678901234567890123456789012345678901234567890123456789012

      SUBROUTINE setTheta(theta)
C     #####################
C >>> Calculate volumes of fine grid blocke (theta field)

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'gloGisementF.h' 
      
      INTEGER i,j,k,l
      REAL theta(NUMMF)

#ifdef DBG 
      WRITE(zz,*) '@DBG: setTheta   (enter)'
#endif
      l=0
      DO k=1,diml(3)               ! calcul des volumes des mailles
       DO j=1,diml(2)              ! fines
        DO i=1,diml(1)
         l=l+1
         theta(l)= longfx(i)*longfy(j)*dz(l)
        END DO
       END DO
      END DO

      RETURN
      END

      SUBROUTINE openerr(io,file)
c     ###########################
      IMPLICIT NONE
      INTEGER i,io
      CHARACTER*128 file

      i=index(file,' ')
      WRITE(*,*)
      PRINT *,"@ERROR: Cannot open file ",file(1:i)
      PRINT *,"@ERROR: iocheck= ",io
      PRINT *,"@ERROR: Bye."
      CALL exit(-1)
      END

       SUBROUTINE avance(fileno,echap,compte)
c      ######################################
c      fileno = le numero de fichier. Le fichier doit
c               etre ouvert
c      echap  = la caracter qui designe une ligne de
c               commentaire
c      compte = le compte des lignes 
c      Au comancement compte doit etre mise a zero.
c      La procedure lire des lignes du fichier jusq'a
c      la premiere ligne qui n'est le commentaire. 
c      Commentaires sont des lignes qui commencent 
c      avec caractere echap.

       IMPLICIT NONE
       INTEGER fileno,compte
       CHARACTER echap
       CHARACTER*80 ligne
       
       READ(fileno,'(A80)',err=101,end=101) ligne
       compte=compte+1
       DO WHILE(ligne(1:1).eq.echap) 
         READ(fileno,'(A80)',err=101,end=101) ligne
         compte=compte+1
       END DO
       backspace(fileno)
       RETURN
101    WRITE(*,*) '@ERROR: procedure avance:'
       WRITE(*,*) '@ERROR while reading file no ',fileno
       WRITE(*,*) '@Bye'
       CALL exit(-1)         
       END

       INTEGER FUNCTION skip(ligne,echap,n)
C      #####################################
C      ligne = la chaine de caracters
C      n     = le nombre de caracters dans ligne qu'on considere
C      echap = le caractere special
C      La fonction supprime les caracteres egales a echap qui se
C      trouvent au commoncement de la ligne. Elle retourne le nombre
C      de caracteres supprimes. Si la ligne est composee seulement 
C      de caracteres egale a echap la ligne n'est pas changee est
C      -1 est retourne.
C      
      IMPLICIT NONE
       CHARACTER*(*) ligne
       CHARACTER*1 echap
       INTEGER n,i,j
    
       i=1
       DO WHILE((i.LT.n).AND.(ligne(i:i).EQ.echap))
         i=i+1
       END DO
       IF(i.EQ.n) THEN ! il y a n-1 blancs
        IF(ligne(n:n).EQ.echap) THEN ! il y a n blancs
          skip=-1
          RETURN
         END IF
       END IF

       IF(i.EQ.1) THEN
        skip=0
        RETURN
       ELSE
        DO j=i,n
         ligne(j-i+1:j-i+1)=ligne(j:j)
        END DO
        DO j=n-i+2,n
         ligne(j:j)=' '
        END DO
       END IF
       skip=i-1
       RETURN
       END


      CHARACTER*3 FUNCTION convrt(count)
C     ##################################
      IMPLICIT NONE
      CHARACTER*32 intFich
      INTEGER count

      WRITE(unit=intFich,fmt='(i3)') count
      READ(unit=intFich,fmt='(a3)',err=100) convrt 
      IF(convrt(1:1).EQ.' ') convrt(1:1)='0'
      IF(convrt(2:2).EQ.' ') convrt(2:2)='0'

      RETURN
100   PRINT *,'@ERROR: convrt()' 
      END

C ================ new function 14/12/2002 Pau

      CHARACTER*3 FUNCTION int2ch(n)
C     ##################################
      IMPLICIT NONE
      CHARACTER*32 intFich
      INTEGER  n

      IF(n.LT.10) THEN
         WRITE(unit=intFich,fmt='(i1)') n
         READ(unit=intFich,fmt='(a1)',err=100) int2ch  
         int2ch(2:2)=' '
         int2ch(3:3)=' '
      ELSE IF(n.LT.100) THEN
         WRITE(unit=intFich,fmt='(i2)') n
         READ(unit=intFich,fmt='(a2)',err=100) int2ch  
         int2ch(3:3)=' '
      ELSE IF(n.LT.1000) THEN
         WRITE(unit=intFich,fmt='(i3)') n
         READ(unit=intFich,fmt='(a3)',err=100) int2ch 
      ELSE
        PRINT *,'@ERROR: int2ch() not implemented for n>=1000.' 
      END IF

      RETURN
100   PRINT *,'@ERROR: int2ch()' 
      END

C ======================================================


      INTEGER FUNCTION FtoG(i)
C     ########################
C     i = indice de la maille fine
C     La fonction rend l'indice de la  maille grossiere a laquelle
C     i appartient.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      INTEGER i,px,py,pz,qx,qy,qz

      CALL Indto3F(i,px,py,pz)

C      (px,py,pz) c'est la position de la maille i dans le 
C                 maillage fin.

      CALL FtoG3(px,py,pz,qx,qy,qz)

C      (qx,qy,qz) c'est la position de la maille i dans le
C                 maillage grossier.

      FtoG=(qz-1)*ngros(2)*ngros(1)+(qy-1)*ngros(1)+qx
      RETURN
      END


      SUBROUTINE Indto3F(i,px,py,pz)
C     ###################################
C     i = l'indice du maillage fin (input)
C     (px,py,pz) est la maille fine correspendant a l'indice i.
C
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'
      INTEGER i,ii,px,py,pz

      ii=i
      pz=(ii-1)/(diml(2)*diml(1))+1
      ii=ii-(pz-1)*diml(2)*diml(1)
      py=(ii-1)/diml(1)+1
      ii=ii-(py-1)*diml(1)
      px=ii
      RETURN 
      END


      SUBROUTINE FtoG3(px,py,pz,qx,qy,qz)
C     ###################################
C     (px,py,pz) est la maille fine.  (input)
C     (qx,qy,qz) est la maille grossiere a quelle (px,py,pz)
C     appartient. (output)

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      INTEGER px,py,pz,qx,qy,qz,k,m

      qx=-777
      qy=-777
      qz=-777
      m=0
      DO k=1,ngros(1)
       m=m+agregx(k)
       IF(px.LE.m) THEN
         qx=k
         GO TO 100
       END IF
      END DO
100   CONTINUE

      m=0
      DO k=1,ngros(2)
       m=m+agregy(k)
       IF(py.LE.m) THEN
         qy=k
         GO TO 200
       END IF
      END DO
200   CONTINUE

      m=0
      DO k=1,ngros(3)
       m=m+agregz(k)
       IF(pz.LE.m) THEN
         qz=k
         GO TO 300
       END IF
      END DO
300   CONTINUE
      RETURN
      END

      INTEGER FUNCTION ordG(i,j,k)
C     ############################
C     i = indice de la maille fine
C     La fonction trouve a quelle maille grossiere i appartient.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      INTEGER i,j,k

      ordG=(k-1)*ngros(2)*ngros(1)+(j-1)*ngros(1)+i
      RETURN
      END

      INTEGER FUNCTION ordF(i,j,k)
C     ############################
C     i = indice de la maille fine
C     La fonction trouve a quelle maille grossiere i appartient.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      INTEGER i,j,k

      ordF=(k-1)*diml(2)*diml(1)+(j-1)*diml(1)+i
      RETURN
      END

      SUBROUTINE hom_file_name(base,n,file) 
C     ###################################################"
C      base is the  name of absolute permeability directory
C      or the base name (without a number) for directory with 
C      mobilities.
C       n refers to mobility directory number n; n=0 refers to 
C      abs. permeability directory.
C      Routine makes in file the file name of homogenized tensor.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      CHARACTER*128 base,file
      CHARACTER*3 nCh,nCh1,nCh2,nCh3,int2ch        
      CHARACTER*64 num
      INTEGER n,ii,i,j,k,l

      nCh1=int2ch(ngros(1))
      nCh2=int2ch(ngros(2))
      nCh3=int2ch(ngros(3))

      ii=index(base,' ')-1
      j=index(nCh1,' ')-1
      k=index(nCh2,' ')-1
      l=index(nCh3,' ')-1
  
      num=nCh1(1:j)//'x'//nCh2(1:k)//'x'//nCh3(1:l)//'  '
      j=index(num,' ')-1

      IF(n.EQ.0) THEN
C        1         2         3         4         5         6         7
C23456789012345678901234567890123456789012345678901234567890123456789012
      file=base(1:ii)//'/'//base(1:ii)//'_'//num(1:j)//'/'//base(1:ii)//
     >'_'//num(1:j)//'.map '
      ELSE
      nCh=int2ch(n)
      i=index(nCh,' ')-1
C23456789012345678901234567890123456789012345678901234567890123456789012
      file=base(1:ii)//nCh(1:i)//'/'//base(1:ii)//nCh(1:i)//'_'//num(1:j
     >)//'/'//base(1:ii)//nCh(1:i)//'_'//num(1:j)//'.map '
      END IF

      RETURN
      END

      SUBROUTINE het_file_name(base,n,file) 
C     ############################################################"
C      base is the  name of absolute permeability directory
C      or the base name (without a number) for directory with 
C      mobilities.
C       n refers to mobility directory number n; n=0 refers to 
C      abs. permeability directory.
C      Routine makes in file the file name of heterogeneous tensor.

      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'dimensions.h'

      CHARACTER*128 base,file
      CHARACTER*3 nCh,nCh1,nCh2,nCh3,int2ch        
      CHARACTER*64 num
      INTEGER n,ii,i,j,k,l

      ii=index(base,' ')-1
  
      IF(n.EQ.0) THEN
      file=base(1:ii)//'/'//base(1:ii)//'.map '
      ELSE
      nCh=int2ch(n)
      i=index(nCh,' ')-1
C23456789012345678901234567890123456789012345678901234567890123456789012
      file=base(1:ii)//nCh(1:i)//'/'//base(1:ii)//nCh(1:i)//'.map '
      END IF

      RETURN
      END

      SUBROUTINE MakeTmpFolders()
C     ###########################
C      Create temprary folders that we need for maps and temporary data.
C
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'

      INTEGER       i,j,ii,count
      CHARACTER*128 file_w,file_o,str
      CHARACTER*3   nCh,int2ch

#ifdef DBG
      WRITE(zz,*) '@DBG: MakeTmpFolders  (enter)'
#endif
      DO count=1,npp-1
         nCh=int2ch(count)
         j=index(nCh,' ')-1
         ii=index(basew,' ')-1
         file_w=basew(1:ii)//nCh(1:j)   ! directory to create
         ii=index(file_w,' ')-1
C23456789012345678901234567890123456789012345678901234567890123456789012
         str="if [ ! -d "//file_w(1:ii)//" ]; then mkdir "//file_w(1:ii)
     >//" ; fi "
         PRINT *, str(1:32+2*ii)
         CALL SYSTEM(str(1:32+2*ii))

         ii=index(baseo,' ')-1
         file_o=baseo(1:ii)//nCh(1:j)   ! directory to create
         ii=index(file_o,' ')-1
         str="if [ ! -d "//file_o(1:ii)//" ]; then mkdir "//file_o(1:ii)
     >//" ; fi "
         PRINT *, str(1:32+2*ii)
         CALL SYSTEM(str(1:32+2*ii))
      END DO

      i=index(DirTmp,' ')-1
C           123456789012345678901234567890123456789012345678901234567890
       str="if [ ! -d "//DirTmp(1:i)//" ] ; then mkdir "//DirTmp(1:i)//"   
     > ; fi   "
       print *,str(1:34+2*i)
       CALL SYSTEM(str(1:34+2*i))

      RETURN
      END


      SUBROUTINE CleanTmpFolders()
C     ############################
C         Remove temporary folders that were created
C
      IMPLICIT NONE
      INCLUDE 'params.h'
      INCLUDE 'fichiers.h'
      INCLUDE 'dimensions.h'

      INTEGER       i,ii,count
      CHARACTER*128 file_w,file_o
      CHARACTER*3   nCh,int2ch

#ifdef DBG
      WRITE(zz,*) '@DBG: CleanTmpFolders  (enter)'
#endif

      DO count=1,npp-1
         nCh=int2ch(count)
         i=index(nCh,' ')-1

         ii=index(basew,' ')-1
         file_w=basew(1:ii)//nCh(1:i)   ! directory to delete
         ii=index(file_w,' ')-1
         WRITE(*,*) '>> Executing: rm -Rf '//file_w(1:ii)
         CALL SYSTEM('rm -Rf '//file_w(1:ii))

         ii=index(baseo,' ')-1
         file_o=baseo(1:ii)//nCh(1:i)   ! directory to delete
         ii=index(file_o,' ')-1
         WRITE(*,*) '>> Executing: rm -Rf '//file_o(1:ii)
         CALL SYSTEM('rm -Rf '//file_o(1:ii))
      END DO

      i=index(DirTmp,' ')-1
      WRITE(*,*) '>> Executing: rm -Rf '//DirTmp(1:i)
      CALL SYSTEM('rm -Rf '//DirTmp(1:i))
      
      RETURN
      END

      SUBROUTINE sep(fullFileName,FolderName,FileName)
C     ###############################################
C            fullFileName (INPUT) path to the file with file name 
C            FolderName   (OUTPUT) folder part in fullFileName
C            FileName     (OUTPUT) file part in fullFileName
C
      CHARACTER*128 fullFileName,FolderName,FileName
      INTEGER i,ii,c
  
      DO i=1,128
        FolderName(i:i)=' '
        FileName(i:i)  =' '
      END DO

      c=0
      ii=index(fullFileName,' ')-1
      DO i=1,ii                                   ! find last / 
         IF(fullFileName(i:i) .EQ. '/') c=i
      END DO
      IF(c.EQ.0) THEN
         DO i=1,ii
           FileName(i:i)  = fullFileName(i:i)
         END DO
      ELSE
         DO i=1,ii-c
           FileName(i:i)  = fullFileName(i+c:i+c)
         END DO
         DO i=1,c-1
            FolderName(i:i)=fullFileName(i:i)
         END DO
      END IF 
      RETURN
      END
