***************************************************************************
** deriveesfbase.f


*     fichier contenant les derivees des fonctions de base sur K^ 
*     selon x et y
*
*              3----------4
*              |          |
*              |          |
*              |    K^    |
*              |          |
*              |          |
*              1----------2
*
*
*

*     dfb1dx   derivee par rapport a x de la fonction de base 
*               associee au sommet 1
*     dfb2dx   derivee par rapport a x de la fonction de base 
*               associee au sommet 2
*     dfb3dx   derivee par rapport a x de la fonction de base 
*               associee au sommet 3
*     dfb4dx   derivee par rapport a x de la fonction de base 
*               associee au sommet 4
*     dfb1dy   derivee par rapport a y de la fonction de base 
*               associee au sommet 1
*     dfb2dy   derivee par rapport a y de la fonction de base 
*               associee au sommet 2
*     dfb3dy   derivee par rapport a y de la fonction de base 
*               associee au sommet 3
*     dfb4dy   derivee par rapport a y de la fonction de base 
*               associee au sommet 4



      real function dfb1dx(x,y)

      implicit none
      real x,y

      dfb1dx=-(1-y)/4

      return

      end

***************************************************************************

      real function dfb2dx(x,y)

      implicit none
      real x,y

      dfb2dx=(1-y)/4

      return

      end

***************************************************************************

      real function dfb3dx(x,y)

      implicit none
      real x,y

      dfb3dx=-(1+y)/4

      return

      end

***************************************************************************

      real function dfb4dx(x,y)

      implicit none
      real x,y

      dfb4dx=(1+y)/4

      return

      end

***************************************************************************
      real function dfb1dy(x,y)

      implicit none
      real x,y

      dfb1dy=-(1-x)/4

      return

      end

***************************************************************************

      real function dfb2dy(x,y)

      implicit none
      real x,y

      dfb2dy=-(1+x)/4

      return

      end

***************************************************************************

      real function dfb3dy(x,y)

      implicit none
      real x,y

      dfb3dy=(1-x)/4

      return

      end

***************************************************************************

      real function dfb4dy(x,y)


      implicit none
      real x,y

      dfb4dy=(1+x)/4

      return

      end
