***************************************************************************
** deriveesfbase.f


*     fichier contenant les derivees des fonctions de base sur K^ 
*     selon x et y
*
*              3----------4
*              |          |
*              |          |
*              |    K^    |
*              |          |
*              |          |
*              1----------2
*
*
*

*     dft1dx   derivee par rapport a x de la fonction test 
*               associee au sommet 1
*     dft2dx   derivee par rapport a x de la fonction test 
*               associee au sommet 2
*     dft3dx   derivee par rapport a x de la fonction test 
*               associee au sommet 3
*     dft4dx   derivee par rapport a x de la fonction test 
*               associee au sommet 4
*     dft1dy   derivee par rapport a y de la fonction test 
*               associee au sommet 1
*     dft2dy   derivee par rapport a y de la fonction test 
*               associee au sommet 2
*     dft3dy   derivee par rapport a y de la fonction test 
*               associee au sommet 3
*     dft4dy   derivee par rapport a y de la fonction test 
*               associee au sommet 4



      real function dft1dx(x,y,a,b)

      implicit none
      real x,y,a,b

      dft1dx=(-1./2-a*3./2*x)*((1-y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************

      real function dft2dx(x,y,a,b)

      implicit none
      real x,y,a,b

      dft2dx=(1./2-a*3./2*x)*((1-y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************

      real function dft3dx(x,y,a,b)

      implicit none
      real x,y,a,b

      dft3dx=(-1./2-a*3./2*x)*((1+y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************

      real function dft4dx(x,y,a,b)

      implicit none
      real x,y,a,b

      dft4dx=(1./2-a*3./2*x)*((1+y)/2+b*3./4*(1-y*y))

      return

      end

***************************************************************************
      real function dft1dy(x,y,a,b)

      implicit none
      real x,y,a,b

      dft1dy=(-1./2-b*3./2*y)*((1-x)/2+a*3./4*(1-x*x))

      return

      end

***************************************************************************

      real function dft2dy(x,y,a,b)

      implicit none
      real x,y,a,b

      dft2dy=(-1./2-b*3./2*y)*((1+x)/2+a*3./4*(1-x*x))

      return

      end

***************************************************************************

      real function dft3dy(x,y,a,b)

      implicit none
      real x,y,a,b

      dft3dy=(1./2-b*3./2*y)*((1-x)/2+a*3./4*(1-x*x))
 
      return

      end

***************************************************************************

      real function dft4dy(x,y,a,b)

      implicit none
      real x,y,a,b

      dft4dy=(1./2-b*3./2*y)*((1+x)/2+a*3./4*(1-x*x))

      return

      end
