*******************************************************
******                ICholeski.f              ********
*
C Ce sous-programme effectue la factorisation de
C Choleski incomplete de la matrice A stockee sous
C forme Morse dans le tableau aa avec les tableaux
C auxiliaires d"indices ia et ja.
C ia(k): indice dans le tableau aa du premier element
C   de la i eme ligne de A stocke dans aa,
C ja(k): indice j de colonne de l"element Aij stocke
C   dans le tableau aa a l"indice k.
C Le resultat est stocke dans le tableau al, qui 
C utilise les memes tableaux auxiliaires d"indices
C ia et ja que aa.
C Le calcul de la factorisation incomplete se fait
C ligne par ligne en terminant par le calcul de 
C l"element diagonal.
C

*	de 'INTRODUCTION AU CALCUL SCIENTIFIQUE' 
*	B. LUCQUIN
*	O. PIRONNEAU
*	MASSON, 1996



      subroutine ICholeski(ns,aa,ia,ja,al)

      implicit none
      
      real aa(*),al(*)
      integer ia(*),ja(*)
      real alij,alii
      integer jlik,jljk,ik,jk
      integer ns,i,j,k

      do 30 i=1,ns

         do 34 k=ia(i),ia(i+1)-2  
            j=ja(k)
            alij=aa(k)
            ik=ia(i)
            jk=ia(j)

 35         if (ik .le. (ia(i+1)-2)) then
               jlik=ja(ik)

 36            if (jk .le. (ia(j+1)-2)) then                  
                  jljk=ja(jk)

                  if (jlik .gt. jljk) then
                     jk=jk+1
                     goto 36

                  elseif (jlik .lt. jljk) then
                        ik=ik+1
                        goto 35
                     
                     else
                        alij=alij-al(ik)*al(jk)
                        ik=ik+1
                        jk=jk+1
                        goto 35
                     end if
                  end if
               end if

               al(k)=alij/al(ia(j+1)-1)
               
 34       continue
         

         alii=aa(ia(i+1)-1)

         do 33 k=ia(i),ia(i+1)-2
            alii=alii-al(k)*al(k)
 33      continue
         
         al(ia(i+1)-1)=sqrt(abs(alii))

 30   continue
 
      
      return
      end





