*******************************************************
******                 ISolvSys.f              ********
*
C Ce sous-programme resout le systeme lineaire
C $LL^T z = r$, ou L est une matrice triangulaire
C inferieure de taille ns x ns, stockee sous forme
C Morse dans les tableaux (al,il,jl). En entree, le 
C tableau z contient le second membre du systeme; 
C en sortie, il contient la solution z.
C La resolution se fait en 2 etapes: une etape de 
C descente, suivie d'une etape de remontee.
C

*	de 'INTRODUCTION AU CALCUL SCIENTIFIQUE' 
*	B. LUCQUIN
*	O. PIRONNEAU
*	MASSON, 1996


      subroutine ISolvSys(ns,z,al,il,jl)

      implicit none
      
      integer ns
      real z(ns),al(*)
      integer il(ns),jl(ns)
      integer i,k,i1,jlk
      real somme

      do 1 i=1,ns
         somme=z(i)
         do 2 k=il(i),il(i+1)-2
            somme=somme-al(k)*z(jl(k))
 2       continue

         z(i)=somme/al(il(i+1)-1)
 1    continue
      
      do 3 i=1,ns
         z(i)=z(i)/al(il(i+1)-1)
 3    continue

      do 4 i1=1,ns
         i=ns+1-i1
         do 4 k=il(i),il(i+1)-2
            jlk=jl(k)
            z(jlk)=z(jlk)-al(k)*z(i)/al(il(jlk+1)-1)
 4    continue

      return
      end





