c  Fichier grad_qua_c.f
c
c***************************************************************
      subroutine GRADIANT_2D_c(GRAD,det,N1,N2,N3,N4,xch,ych)
c***************************************************************
c
c   Cette procedure calcule le gradiant des fonctions de base 
c   au point (xch,yxch) pour le carre de reference
c
c   GRAD: tableau contenant les valeurs des gradiants des 
c         fonctions de bases  
c   det: jacobien de la transformation: carre de reference --> quadrilatere 
c   N1,N2,N3,N4: contient les numeros, ainsi que les coordonnees des
c                quatre points qui constituent le quadrilatere
c   xch,ych: coordonnees du point de calcul
c
c

      implicit none

      real*8    GRAD,xch,ych,det,N1,N2,N3,N4,J11,J12,J21,J22
      dimension GRAD(4,*),N1(*),N2(*),N3(*),N4(*) 
c
c calcul du jacobien de la transformation
c
      J11=-N1(2)+N2(2)+N3(2)-N4(2)+ych*(N1(2)-N2(2)+N3(2)-N4(2))
      J11=J11/4.d0

      J12=-N1(3)+N2(3)+N3(3)-N4(3)+ych*(N1(3)-N2(3)+N3(3)-N4(3)) 
      J12=J12/4.d0

      J21=-N1(2)-N2(2)+N3(2)+N4(2)+xch*(N1(2)-N2(2)+N3(2)-N4(2))
      J21=J21/4.d0

      J22=-N1(3)-N2(3)+N3(3)+N4(3)+xch*(N1(3)-N2(3)+N3(3)-N4(3))
      J22=J22/4.d0

      det=(J11*J22)-(J21*J12)
c
c calcul du gradiant               
c
      GRAD(1,1)=(J22/det)*((ych-1)/4.d0)-(J12/det)*((xch-1)/4.d0)
      GRAD(1,2)=(-J21/det)*((ych-1)/4.d0)+(J11/det)*((xch-1)/4.d0)
      
      GRAD(2,1)=(J22/det)*((1-ych)/4.d0)-(J12/det)*((-xch-1)/4.d0)
      GRAD(2,2)=(-J21/det)*((1-ych)/4.d0)+(J11/det)*((-xch-1)/4.d0) 

      GRAD(3,1)=(J22/det)*((ych+1)/4.d0)-(J12/det)*((xch+1)/4.d0)
      GRAD(3,2)=(-J21/det)*((ych+1)/4.d0)+(J11/det)*((xch+1)/4.d0) 
      
      GRAD(4,1)=(J22/det)*((-ych-1)/4.d0)-(J12/det)*((1-xch)/4.d0)
      GRAD(4,2)=(-J21/det)*((-ych-1)/4.d0)+(J11/det)*((1-xch)/4.d0) 
      
      RETURN
      end                                        
