c  Fichier hexa_c.f
c
c********************************************************************
c             FICHIERS NECESSAIRES A LA SUBROUTINE CALCULP1
c********************************************************************

      INCLUDE'grad_hex_c.f'
      INCLUDE'prod_hex_c.f'
      INCLUDE'rige_hex_c.f'
      INCLUDE'base_hex_c.f'
      INCLUDE'2mb_hex_c.f'
      INCLUDE'volume2_c.f'
      
c**********************************************************************
      subroutine CALCULQ1_C(ELEMENTBIS,INDICE,bb,ib,jb,aa,ia,ja,SMinter,
     @       N1,N2,N3,N4,N5,N6,N7,N8,K,cc,ic,jc,volume,poro,poroh,MOY)
c**********************************************************************
c
c  Cette procedure calcule les differentes contributions amenees par
c  un hexaedre, et effectue l'assemblage.
c  On sauvegarde egalement certains resultats necessaire en vue du
c  calcul du tenseur homogeneise dans les tableaux bb et cc.
c
c  ELEMENTBIS: tableau qui permet de dire si un noeud de l'element est
c              sur le bord ou non.
c  INDICE:  tableau donnant le rang d'un noeud appartenant a VECTI ou VECTF
c  bb: tableau contenant les contributions bord-bord
c  aa: tableau contenant les contributions int-int (c'est la matrice A
c      du systeme lineaire)
c  cc: tableau contenant les contributions bord-int
c  ia(k): indice dans le tableau aa du premier element
c        de la i eme ligne de A stocke dans aa,
c  ja(k): indice j de colonne de l"element Aij stocke
c         dans le tableau aa a l"indice k
c  ib,jb: idem que ia et ja pour le tableau bb
c  ic,jc: idem que ia et ja pour le tableau cc
c  SMinter:vecteur contenant le second membre du systeme lineaire
c            sans les conditions aux limites
c   N1,N2,N3,N4,N5,N6,N7,N8: contient les numeros, ainsi que les coordonnees 
c                           des points qui constituent l'hexaedre
c   K: tableau contenant le tenseur des permeabilites
c   poro: variable contenant la valeur de la porosite
c   poroh: variable contenant la porosite moyenne
c   MOY:  tableau contenant la moyenne arithmetique et la moyenne
c         harmonique des permeabilites
c   volume :volume de la grosse maille (ou de la boite englobante)
c
      implicit none           

      integer   ele,INDICE,l,nbr1,ia,ja,ib,jb,ic,jc,nbr2,k1,k2,ent,i
c      integer   iii,jjj
      real*8    K,N1,N2,N3,N4,N5,N6,N7,N8,GRAD,det,som1,volume0,volume1 
      real*8    INTEGRALE_C,aa,bb,cc,SMinter,volume,poro,poroh,MOY      
c      real*8    INTEGRPQ_C
      logical   ELEMENTBIS,log1,log2
      dimension N1(*),N2(*),N3(*),N4(*),N5(*),N6(*),N7(*),N8(*)
      dimension GRAD(8,3),SMinter(*),bb(*),ib(*),jb(*)
      dimension ELEMENTBIS(*),INDICE(*),K(3,*)
      dimension aa(*),ia(*),ja(*),cc(*),ic(*),jc(*),MOY(*)

c calcul du volume

      call VOLUME_ELE2_C(volume0,N1,N2,N4,N5)      
      call VOLUME_ELE2_C(volume1,N4,N5,N6,N8)
      volume0=volume0+volume1
      call VOLUME_ELE2_C(volume1,N2,N4,N5,N6)
      volume0=volume0+volume1
      call VOLUME_ELE2_C(volume1,N2,N3,N4,N7)
      volume0=volume0+volume1
      call VOLUME_ELE2_C(volume1,N4,N6,N7,N8)
      volume0=volume0+volume1
      call VOLUME_ELE2_C(volume1,N2,N4,N6,N7)
      volume0=volume0+volume1
     
      volume=volume+volume0

c calcul de la contribution et affectation de la porosite moyenne

      poroh=poroh+(poro*volume0)

c calcul des contributions et affectation des moyennes arithmetique
c et harmonique des permeabilites

      do i=1,3
         MOY(i)=MOY(i)+(K(i,i)*volume0)
      enddo
      do i=4,6
         MOY(i)=MOY(i)+(volume0/K(i-3,i-3))
      enddo

c boucle sur tous les noeuds de l'element avec 
c une boucle interne sur les noeuds dont le cardinal est decroissant

      do ele=2,9
         nbr1=ele-1
         log2=.not.ELEMENTBIS(ele)
         do l=ele,9
            write(20,*)'ele,l',ele,' ',l,ELEMENTBIS(ele),ELEMENTBIS(l)
            nbr2=l-1
            k1=INDICE(ele)
            k2=INDICE(l)
            log1=.not.ELEMENTBIS(l)

c calcul de la contribution

            som1=INTEGRALE_C(GRAD,N1,N2,N3,N4,N5,N6,N7,N8,K,det,
     @                       nbr1,nbr2)
      write(20,*)'som1_bon',som1

c assemblage

            if (log1.and.log2) then
                     if (k2.gt.k1) then                         
                                  ent=k1
                                  k1=k2
                                  k2=ent
                     endif                                      
                     call ASSEMBLAGE_C(bb,ib,jb,k1,k2,som1)
            else
            
            if (ELEMENTBIS(ele).and.ELEMENTBIS(l)) then
                     if (k2.gt.k1) then 
                                  ent=k1
                                  k1=k2
                                  k2=ent
                     endif                                      
                     call ASSEMBLAGE_C(aa,ia,ja,k1,k2,som1)
            else

            log1=.not.ELEMENTBIS(l)
        if (ELEMENTBIS(ele).and.log1) then                      
                     call ASSEMBLAGEbis_C(cc,ic,jc,k2,k1,som1)
                else

          if (ELEMENTBIS(l)) then 
                     k1=INDICE(l)
                     k2=INDICE(ele)
                     call ASSEMBLAGEbis_C(cc,ic,jc,k2,k1,som1)
              endif     
            endif
           endif
         endif
        enddo

c calcul de la contribution du second membre et assemblage
c ici f=0 donc on met des commentaires pour gagner du temps cpu

c        if (ELEMENTBIS(ele)) then
c            k1=INDICE(ele) 
c           SMinter(k1)=SMinter(k1)+
c     @                 INTEGRPQ_C(nbr1,N1,N2,N3,N4,N5,N6,N7,N8)
c        endif

      enddo

      RETURN
      end
