c  Fichier prod_hex_c.f
c
c*********************************************************
      real*8 function PRODUIT_C(K,GRAD,nbr1,nbr2)
c********************************************************
c
c   Cette fonction calcule le produit scalaire de 
c   [K(x)GRAD(u).GRAD(v)],u et v designant deux fonctions de base 
c   quelconque de l'hexaedre.
c
c   K: tableau contenant le tenseur des permeabilites
c   GRAD: tableau contenant les valeurs des  gradiants
c         des fonctions de base
c   nbr1,nbr2: numero designant la nbr1ieme et la nbr2ieme
c              fonction de base

      implicit none

      integer   nbr1,nbr2   
      real*8    K,GRAD
      dimension GRAD(8,*),K(3,*)

c produit scalaire

       PRODUIT_C=K(1,1)*GRAD(nbr1,1)*GRAD(nbr2,1)+
     @         K(1,2)*GRAD(nbr1,2)*GRAD(nbr2,1)+
     @         K(1,3)*GRAD(nbr1,3)*GRAD(nbr2,1)+
     @         K(2,1)*GRAD(nbr1,1)*GRAD(nbr2,2)+
     @         K(2,2)*GRAD(nbr1,2)*GRAD(nbr2,2)+
     @         K(2,3)*GRAD(nbr1,3)*GRAD(nbr2,2)+
     @         K(3,1)*GRAD(nbr1,1)*GRAD(nbr2,3)+
     @         K(3,2)*GRAD(nbr1,2)*GRAD(nbr2,3)+
     @         K(3,3)*GRAD(nbr1,3)*GRAD(nbr2,3)

c       write(20,*)'PRODUIT_C',PRODUIT_C

      RETURN
      end
                         

