C  Fichier resol_sys_c.f
C
C******************************************************************
            SUBROUTINE ISolvSys_c(ns,z,al,il,jl)
C******************************************************************
c
C Ce sous-programme resout le systeme lineaire
C LL^T z = r, ou L est une matrice triangulaire
C inferieure de taille ns x ns, stockee sous forme
C Morse dans les tableaux (al,il,jl). En entree, le 
C tableau z contient le second membre du systeme; 
C en sortie, il contient la solution z.
C La resolution se fait en 2 etapes: une etape de 
C descente, suivie d'une etape de remontee.

      implicit none
      INTEGER ns,i,i1,k,jlk,il,jl
      REAL*8  al,z,somme
      DIMENSION z(*),al(*),il(*),jl(*)

      DO  i=1,ns
        somme=z(i)
        DO  k=il(i), il(i+1)-2
          somme=somme-al(k)*z(jl(k))
        enddo
        z(i)=somme/al(il(i+1)-1)
      enddo
      DO  i=1,ns
        z(i) = z(i)/al(il(i+1)-1)
      enddo
      DO  i1=1,ns
        i=ns+1-i1
        DO  k=il(i), il(i+1)-2
          jlk=jl(k)
          z(jlk) = z(jlk) - al(k)*z(i)/al(il(jlk+1)-1)
        enddo
      enddo

      RETURN
      END
