c   Fichier grad_hex_c.f
c
c************************************************************************
      subroutine GRADIANT_C(GRAD,det,N1,N2,N3,N4,N5,N6,N7,N8,
     @                      xch,ych,zch)
c************************************************************************
c
c   Cette procedure calcule le gradiant des fonctions de base
c   au point (xch,ych,zch) pour un hexaedre
c
c   GRAD: tableau contenant les valeurs des gradiants des
c         fonctions de bases
c   det: jacobien de la transformation: cube de reference --> hexaedre
c   N1,N2,N3,N4,N5,N6,N7,N8: contient les numeros, ainsi que les coordonnees 
c                des points qui constituent l'hexaedre
c   xch,ych,zch: coordonnees du point de calcul

      implicit none

      real*8    GRAD,xch,ych,zch,det,N1,N2,N3,N4,N5,N6,N7,N8
      real*8    J11,J12,J13,J21,J22,J23,J31,J32,J33,a1,a2,b1,b2,c1,c2 
      real*8    aux1,aux2,aux3,a,b,c,d,e,f,g,h,i
c      integer   ii,jj
      dimension N1(*),N2(*),N3(*),N4(*),N5(*),N6(*),N7(*),N8(*)
      dimension GRAD(8,*)      

c calcul du jacobien de la transformation

c      write(20,*)'N1',(N1(ii),ii=2,4)
c      write(20,*)'N2',(N2(ii),ii=2,4)
c      write(20,*)'N3',(N3(ii),ii=2,4)
c      write(20,*)'N4',(N4(ii),ii=2,4)
c      write(20,*)'N5',(N5(ii),ii=2,4)
c      write(20,*)'N6',(N6(ii),ii=2,4)
c      write(20,*)'N7',(N7(ii),ii=2,4)
c      write(20,*)'N8',(N8(ii),ii=2,4)

    
      a1=(1.d0+xch)
      a2=(1.d0-xch)
      b1=(1.d0+ych)
      b2=(1.d0-ych)
      c1=(1.d0+zch)
      c2=(1.d0-zch)

      J11=((-b2*c2)*N1(2)+(b2*c2)*N2(2)+(b1*c2)*N3(2)+(-b1*c2)*N4(2)+
     @    (-b2*c1)*N5(2)+(b2*c1)*N6(2)+(b1*c1)*N7(2)+(-b1*c1)*N8(2))/8

      J21=((-a2*c2)*N1(2)+(-a1*c2)*N2(2)+(a1*c2)*N3(2)+(a2*c2)*N4(2)+
     @    (-a2*c1)*N5(2)+(-a1*c1)*N6(2)+(a1*c1)*N7(2)+(a2*c1)*N8(2))/8

      J31=((-a2*b2)*N1(2)+(-a1*b2)*N2(2)+(-a1*b1)*N3(2)+(-a2*b1)*N4(2)+
     @    (a2*b2)*N5(2)+(a1*b2)*N6(2)+(a1*b1)*N7(2)+(a2*b1)*N8(2))/8
      
      J12=((-b2*c2)*N1(3)+(b2*c2)*N2(3)+(b1*c2)*N3(3)+(-b1*c2)*N4(3)+
     @    (-b2*c1)*N5(3)+(b2*c1)*N6(3)+(b1*c1)*N7(3)+(-b1*c1)*N8(3))/8

      J22=((-a2*c2)*N1(3)+(-a1*c2)*N2(3)+(a1*c2)*N3(3)+(a2*c2)*N4(3)+
     @    (-a2*c1)*N5(3)+(-a1*c1)*N6(3)+(a1*c1)*N7(3)+(a2*c1)*N8(3))/8

      J32=((-a2*b2)*N1(3)+(-a1*b2)*N2(3)+(-a1*b1)*N3(3)+(-a2*b1)*N4(3)+
     @    (a2*b2)*N5(3)+(a1*b2)*N6(3)+(a1*b1)*N7(3)+(a2*b1)*N8(3))/8
      
      J13=((-b2*c2)*N1(4)+(b2*c2)*N2(4)+(b1*c2)*N3(4)+(-b1*c2)*N4(4)+
     @    (-b2*c1)*N5(4)+(b2*c1)*N6(4)+(b1*c1)*N7(4)+(-b1*c1)*N8(4))/8

      J23=((-a2*c2)*N1(4)+(-a1*c2)*N2(4)+(a1*c2)*N3(4)+(a2*c2)*N4(4)+
     @    (-a2*c1)*N5(4)+(-a1*c1)*N6(4)+(a1*c1)*N7(4)+(a2*c1)*N8(4))/8

      J33=((-a2*b2)*N1(4)+(-a1*b2)*N2(4)+(-a1*b1)*N3(4)+(-a2*b1)*N4(4)+
     @    (a2*b2)*N5(4)+(a1*b2)*N6(4)+(a1*b1)*N7(4)+(a2*b1)*N8(4))/8

      
      det=J11*(J22*J33-J32*J23)+J12*(J31*J23-J21*J33)+
     @     J13*(J21*J32-J31*J22)

c       write(20,*)'det',det

c calcul du gradiant                

      a=(J22*J33-J32*J23)/det
      b=(J13*J32-J12*J33)/det
      c=(J12*J23-J13*J22)/det
      d=(J31*J23-J21*J33)/det
      e=(J11*J33-J13*J31)/det
      f=(J21*J13-J23*J11)/det
      g=(J21*J32-J31*J22)/det
      h=(J12*J31-J32*J11)/det
      i=(J11*J22-J12*J21)/det

      aux1=(-b2*c2)/8.d0
      aux2=(-a2*c2)/8.d0
      aux3=(-a2*b2)/8.d0
      GRAD(1,1)=a*aux1+b*aux2+c*aux3
      GRAD(1,2)=d*aux1+e*aux2+f*aux3
      GRAD(1,3)=g*aux1+h*aux2+i*aux3

      aux1=(b2*c2)/8.d0
      aux2=(-a1*c2)/8.d0
      aux3=(-a1*b2)/8.d0
      GRAD(2,1)=a*aux1+b*aux2+c*aux3
      GRAD(2,2)=d*aux1+e*aux2+f*aux3
      GRAD(2,3)=g*aux1+h*aux2+i*aux3

      aux1=(b1*c2)/8.d0
      aux2=(a1*c2)/8.d0
      aux3=(-a1*b1)/8.d0
      GRAD(3,1)=a*aux1+b*aux2+c*aux3
      GRAD(3,2)=d*aux1+e*aux2+f*aux3
      GRAD(3,3)=g*aux1+h*aux2+i*aux3
      
      aux1=(-b1*c2)/8.d0
      aux2=(a2*c2)/8.d0
      aux3=(-a2*b1)/8.d0
      GRAD(4,1)=a*aux1+b*aux2+c*aux3
      GRAD(4,2)=d*aux1+e*aux2+f*aux3
      GRAD(4,3)=g*aux1+h*aux2+i*aux3

      aux1=(-b2*c1)/8.d0
      aux2=(-a2*c1)/8.d0
      aux3=(a2*b2)/8.d0
      GRAD(5,1)=a*aux1+b*aux2+c*aux3
      GRAD(5,2)=d*aux1+e*aux2+f*aux3
      GRAD(5,3)=g*aux1+h*aux2+i*aux3

      aux1=(b2*c1)/8.d0
      aux2=(-a1*c1)/8.d0
      aux3=(a1*b2)/8.d0
      GRAD(6,1)=a*aux1+b*aux2+c*aux3
      GRAD(6,2)=d*aux1+e*aux2+f*aux3
      GRAD(6,3)=g*aux1+h*aux2+i*aux3
      
      aux1=(b1*c1)/8.d0
      aux2=(a1*c1)/8.d0
      aux3=(a1*b1)/8.d0
      GRAD(7,1)=a*aux1+b*aux2+c*aux3
      GRAD(7,2)=d*aux1+e*aux2+f*aux3
      GRAD(7,3)=g*aux1+h*aux2+i*aux3

      aux1=(-b1*c1)/8.d0
      aux2=(a2*c1)/8.d0
      aux3=(a2*b1)/8.d0
      GRAD(8,1)=a*aux1+b*aux2+c*aux3
      GRAD(8,2)=d*aux1+e*aux2+f*aux3
      GRAD(8,3)=g*aux1+h*aux2+i*aux3


c      do ii=1,8
c         write(20,*)(GRAD(ii,jj),jj=1,3)
c      enddo
      
      RETURN
      end                                        

