c  Fichier volume2_c.f
c
c************************************************************
      subroutine VOLUME_ELE2_C(volume,N1,N2,N3,N4)
c************************************************************
c
c   Cette procedure calcule le gradiant des differentes fonctions
c   de base pour un tetraedre.
c
c   N1,N2,N3,N4: contient les numeros, ainsi que les coordonnees des
c                quatre points qui constituent le tetraedre
c   GRADP: tableau contenant les valeurs des  gradiants
c         des fonctions de base
c   det:jacobien de la transformation:tetraedre de reference --> tetraedre

      implicit none
      
      real*8    volume,det,N1,N2,N3,N4,a,d,g
      real*8    J11,J12,J13,J21,J22,J23,J31,J32,J33 
      dimension N1(*),N2(*),N3(*),N4(*)

c calcul du jacobien de la transformation
       
      J11=-N1(2)+N2(2)
      J21=-N1(2)+N3(2)
      J31=-N1(2)+N4(2)
      
      J12=-N1(3)+N2(3)
      J22=-N1(3)+N3(3)
      J32=-N1(3)+N4(3)

      J13=-N1(4)+N2(4)
      J23=-N1(4)+N3(4)
      J33=-N1(4)+N4(4)

      a=(J22*J33-J32*J23) 
      d=(J31*J23-J21*J33) 
      g=(J21*J32-J31*J22)

      det=J11*a+J12*d+J13*g

c calcul du volume     

      volume=(ABS(det))/6.d0     

      RETURN
      end                                        
      

